#pragma once
#include <string_view>
#include <sstream>

namespace console
{

// Allow full specializations to implement custom serialization
// logic for your types. The current implementation is just to
// get it working, but could be much more sophisticated.
template <typename T>
struct ConsoleParser
{
    static std::string serialize(T const& input)
    {
        std::stringstream ss;
        ss << input;
        return ss.str();
    }

    static bool deserialize(T& output, std::string_view const input)
    {
        T intermediate{};
        std::stringstream ss;
        ss << input;
        ss >> intermediate;
        if (ss.fail())
        {
            return false;
        }
        output = std::move(intermediate);
        return true;
    }
};

} // namespace console
