#pragma once
#include "parser.hpp"
#include <framework/color.hpp>

namespace console
{
    
template <>
struct ConsoleParser<fw::Color>
{
    static std::string serialize(fw::Color const& input)
    {
        auto hex_str = input.to_hex_string();
        return { &hex_str[0] };
    }

    static bool deserialize(fw::Color& output, std::string_view const input)
    {
        auto const parse_result = fw::Color::from_hex_string(input);
        if (parse_result.has_value())
        {
            output = *parse_result;
            return true;
        }
        return false;
    }
};

} // namespace console
