#include "type_list.hpp"
#include <type_traits>

using namespace particles::detail;

static_assert(std::is_same_v<
    TypeList<bool, float, int, char, unsigned>,
    ConcatTypeList<TypeList<bool, float, int>, TypeList<char, unsigned>>
>);

static_assert(std::is_same_v<
    bool,
    IndexTypes<0, bool, int, float>
>);
static_assert(std::is_same_v<
    int,
    IndexTypes<1, bool, int, float>
>);
static_assert(std::is_same_v<
    float,
    IndexTypes<2, bool, int, float>
>);

static_assert( ContainsType<int, float, double, int, void>);
static_assert(!ContainsType<short, float, double, int, void>);
static_assert( ListContainsType<int, TypeList<float, double, int, void>>);
static_assert(!ListContainsType<short, TypeList<float, double, int, void>>);

static_assert(std::is_same_v<
    TypeList<bool, int, float, double>,
    AppendTypeUnique<double, bool, int, float>
>);
static_assert(std::is_same_v<
    TypeList<bool, int, float>,
    AppendTypeUnique<int, bool, int, float>
>);

static_assert(std::is_same_v<
    TypeList<int, bool, double, float>,
    UniqueTypeList<int, bool, bool, double, int, float, float, double, bool>
>);
