#pragma once

#include <cstdint>
#include <cstddef>

#define FW_FORCE_INLINE __forceinline

namespace fw
{

using u8  = std::uint8_t;
using u16 = std::uint16_t;
using u32 = std::uint32_t;
using u64 = std::uint64_t;
    
using i8  = std::int8_t;
using i16 = std::int16_t;
using i32 = std::int32_t;
using i64 = std::int64_t;

using f32 = float;
using f64 = double;

using usize = std::size_t;
#if defined(_WIN32)
#if defined(_WIN64)
using isize = i64;
#else
using isize = i32;
#endif
#else
#error "Windows specific"
#endif
static_assert(sizeof(usize) == sizeof(isize));

} // namespace fw
