#pragma once
#include "render_incl.hpp"
#include "shader.hpp"
#include <initializer_list>
#include <utility>

namespace fw
{

class GlShaderProgram
{
public:
    GlShaderProgram();
    GlShaderProgram(std::initializer_list<GlShader> shaders);

    GlShaderProgram(GlShaderProgram const&) = delete;
    GlShaderProgram& operator=(GlShaderProgram const&) = delete;

    GlShaderProgram(GlShaderProgram&& rhs) noexcept;
    GlShaderProgram& operator=(GlShaderProgram&& rhs) noexcept;

    ~GlShaderProgram();

    void swap(GlShaderProgram& rhs) noexcept
    {
        std::swap(shader_program_id_, rhs.shader_program_id_);
    }
    GLuint id() const noexcept { return shader_program_id_; }

private:
    GLuint shader_program_id_;
};
inline void swap(GlShaderProgram& lhs, GlShaderProgram& rhs) noexcept
{
    lhs.swap(rhs);
}

} // namespace fw
