#include <type_traits>

int add(int a, int b) { return a + b; }
using AddPtr = int(*)(int, int);

static_assert(!std::is_same_v<decltype( add), AddPtr>);
static_assert( std::is_same_v<decltype(&add), AddPtr>);
static_assert(!std::is_function_v<AddPtr>);
static_assert( std::is_pointer_v<AddPtr>);
static_assert( std::is_function_v<std::remove_pointer_t<AddPtr>>);

using Array1 = int[2];    // int      [2]
using Array2 = Array1[3]; // int   [3][2]
using Array3 = Array2[5]; // int[5][3][2]

static_assert(std::rank_v<Array1> == 1);
static_assert(std::rank_v<Array2> == 2);
static_assert(std::rank_v<Array3> == 3);
static_assert(std::extent_v<Array1, 0> == 2);
static_assert(std::extent_v<Array2, 0> == 3);
static_assert(std::extent_v<Array2, 1> == 2);
static_assert(std::extent_v<Array3, 0> == 5);
static_assert(std::extent_v<Array3, 1> == 3);
static_assert(std::extent_v<Array3, 2> == 2);

static_assert(std::is_same_v<std::remove_extent_t<Array3>, Array2>);
static_assert(std::is_same_v<std::remove_extent_t<Array2>, Array1>);
static_assert(std::is_same_v<std::remove_extent_t<Array1>, int>);
static_assert(std::is_same_v<std::remove_all_extents_t<Array3>, int>);
static_assert(std::is_same_v<std::remove_all_extents_t<Array2>, int>);
static_assert(std::is_same_v<std::remove_all_extents_t<Array1>, int>);

static_assert(std::is_same_v<Array1, int[2]>);
static_assert(std::is_same_v<Array2, int[3][2]>);
static_assert(std::is_same_v<Array3, int[5][3][2]>);
