#include <iostream>
#include <type_traits>

struct HasX { int x; };
struct HasY { int y; };

template <typename T, typename = decltype(T::x)>
void print_xy(T const& object)
{
    std::cout << "x: " << object.x << "\n";
}

template <typename T, typename = decltype(T::y), typename = void>
void print_xy(T const& object)
{
    std::cout << "y: " << object.y << "\n";
}

static void example()
{
    HasX has_x{ 3 };
    print_xy(has_x); // calls void print_xy<HasX, int>(HasX const&)
    HasY has_y{ 5 };
    print_xy(has_y); // calls void print_xy<HasY, int, void>(HasY const&)
}
