#include <type_traits>

struct HasX { int x; };
struct HasY { int y; };

template <typename T, typename = void>
constexpr bool has_x = false;
template <typename T>
constexpr bool has_x<T, std::void_t<decltype(T::x)>> = true;

static_assert( has_x<HasX>);
static_assert(!has_x<HasY>);

template <typename T, typename XType>
constexpr bool has_x_of = false;
template <typename T>
constexpr bool has_x_of<T, decltype(T::x)> = true;

static_assert( has_x_of<HasX, int  >);
static_assert(!has_x_of<HasX, float>);
static_assert(!has_x_of<HasY, int  >);
static_assert(!has_x_of<HasY, float>);
