// Code is horrible #donttry
var CodeSample;
(function (CodeSample) {
    class Formatter {
    }
    CodeSample.Formatter = Formatter;
    class Code {
        constructor(code) {
            assert(code.lines.length === code.tokens.length, 'Line and token length must match.');
            this.lines = code.lines.map((line, index) => {
                return {
                    content: line,
                    tokens: code.tokens[index].reduce((state, value, index) => {
                        if (index % 2 === 0) {
                            state.color = value;
                            return state;
                        }
                        state.tokens.push({
                            color: state.color,
                            range: [state.current_column, state.current_column + value]
                        });
                        state.current_column += value;
                        return state;
                    }, {
                        current_column: 0,
                        color: '#ffffff',
                        tokens: []
                    }).tokens,
                    attachments: {}
                };
            });
            this.sets = {};
            // Default code set just shows all lines
            if (!code.sets) {
                this.sets['main'] = [this.lines.map((line, index) => ({
                        type: 'show_line',
                        line_index: index
                    }))];
                return;
            }
            for (const set_name in code.sets) {
                this.sets[set_name] = Code.transform_set(code.sets[set_name], this.lines.length);
            }
        }
        /**
         * Horrible mess that transforms JSON set to TypeScript Set.
         * @param set JSON set.
         */
        static transform_set(set, line_count) {
            assert(set instanceof Array, 'set must be an array');
            return set.map(frame => {
                if (frame === null) {
                    return;
                }
                assert(frame instanceof Array, 'set frames must be an array or null');
                const actions = [];
                for (let i = 0; i < frame.length;) {
                    if (frame[i] === null) {
                        return;
                    }
                    assert(typeof frame[i] === 'string', 'frame must have a string command');
                    const command = frame[i];
                    let args = [];
                    for (++i; i < frame.length; i++) {
                        if (typeof (frame[i]) === 'string') {
                            break;
                        }
                        args.push(frame[i]);
                    }
                    switch (command) {
                        case 'sl':
                        case 'hl':
                            {
                                assert(args.length !== 0, 'hl/sl require at least 1 argument');
                                const lines = [];
                                args.forEach(range => {
                                    if (typeof range === 'number') {
                                        lines.push(range);
                                        return;
                                    }
                                    assert(range instanceof Array, 'line range must be an array');
                                    assert(range.length === 2, 'line range must be length 2');
                                    assert(typeof range[0] === 'number'
                                        && typeof range[1] === 'number', 'line range must contain two numbers');
                                    const low = Math.min(range[0], range[1]);
                                    const high = Math.max(range[0], range[1]);
                                    for (let j = low; j <= high; j++) {
                                        lines.push(j);
                                    }
                                });
                                const type = command === 'sl' ? 'show_line' : 'hide_line';
                                actions.push(...lines.map(line => {
                                    assert(line >= 1 && line <= line_count, 'line out of range');
                                    return {
                                        type: type,
                                        line_index: line - 1
                                    };
                                }));
                            }
                            break;
                        case 'cn':
                            {
                                assert(args.length === 0, 'cn does not take arguments');
                                actions.push({ type: 'clear_notes' });
                            }
                            break;
                        case 'sn':
                            actions.push({ type: 'clear_notes' });
                        case 'an':
                            {
                                assert(args.length !== 0, 'sn/an require arguments');
                                args.forEach(note => {
                                    assert(note instanceof Array, 'note description must be an array');
                                    assert(note.length >= 3 && note.length <= 4, 'invalid note description');
                                    if (typeof note[3] === 'undefined') {
                                        note[3] = 'info';
                                    }
                                    assert(typeof note[0] === 'number'
                                        && typeof note[1] === 'number'
                                        && typeof note[2] === 'string'
                                        && (note[3] === 'question'
                                            || note[3] === 'info'
                                            || note[3] === 'warning'
                                            || note[3] === 'error'), 'invalid note description');
                                    actions.push({
                                        type: 'add_note',
                                        line_index: note[0] - 1,
                                        start_column: note[1],
                                        content: note[2],
                                        note_type: note[3]
                                    });
                                });
                            }
                            break;
                        case 'cm':
                            {
                                if (args.length === 0) {
                                    actions.push({ type: 'clear_markers', marker_types: ['highlight', 'positive', 'negative'] });
                                }
                                else {
                                    assert(args.length === 1, 'cm can take at most 1 argument');
                                    assert(args[0] instanceof Array, 'cm argument must be an array');
                                    args[0].forEach((x) => assert(x === 'highlight'
                                        || x === 'positive'
                                        || x === 'negative'
                                        || x === 'hide', 'invalid clear command'));
                                    actions.push({ type: 'clear_markers', marker_types: args[0] });
                                }
                            }
                            break;
                        case 'sm':
                            actions.push({ type: 'clear_markers', marker_types: ['highlight', 'positive', 'negative'] });
                        case 'am':
                            {
                                assert(args.length !== 0, 'sm/am require arguments');
                                args.forEach(marker => {
                                    assert(marker instanceof Array, 'marker description must be an array');
                                    assert(marker.length >= 3 && marker.length <= 4, 'invalid marker description');
                                    if (typeof marker[3] === 'undefined') {
                                        marker[3] = 'highlight';
                                    }
                                    assert(typeof marker[0] === 'number'
                                        && typeof marker[1] === 'number'
                                        && typeof marker[2] === 'number'
                                        && (marker[3] === 'highlight'
                                            || marker[3] === 'positive'
                                            || marker[3] === 'negative'
                                            || marker[3] === 'hide'), 'invalid marker description');
                                    const range = marker[1] <= marker[2]
                                        ? [marker[1], marker[2]]
                                        : [marker[2], marker[1]];
                                    actions.push({
                                        type: 'add_marker',
                                        line_index: marker[0] - 1,
                                        range: range,
                                        marker_type: marker[3]
                                    });
                                });
                            }
                            break;
                        case 'sc':
                        case 'hc':
                            {
                                assert(args.length !== 0, 'sc/hc requires at least 1 argument');
                                args.forEach((arg) => {
                                    assert(arg instanceof Array, 'sc/hc arguments must be arrays');
                                    assert(arg.length === 3, 'sc/hc arguments must be 3 long arrays');
                                    assert(typeof arg[0] === 'number'
                                        && typeof arg[1] === 'number'
                                        && typeof arg[2] === 'number', 'sc/hc argument arrays must contain numbers');
                                    assert(arg[0] >= 1 && arg[0] <= line_count, 'sc/hc line out of range');
                                    if (arg[1] === arg[2]) {
                                        return;
                                    }
                                    const range = arg[1] < arg[2]
                                        ? [arg[1], arg[2]]
                                        : [arg[2], arg[1]];
                                    if (command === 'sc') {
                                        actions.push({
                                            type: 'show_characters',
                                            line_index: arg[0] - 1,
                                            range: range
                                        });
                                    }
                                    else {
                                        actions.push({
                                            type: 'hide_characters',
                                            line_index: arg[0] - 1,
                                            range: range
                                        });
                                    }
                                });
                            }
                            break;
                    }
                }
                return actions;
            }).filter(x => x);
        }
        render(code_elem) {
            const set_name = code_elem.data('set') || 'main';
            const set = this.sets[set_name] || this.sets.main;
            const frame_offset = parseInt(code_elem.data('frame-offset') || '0', 10) || 0;
            code_elem.addClass('code-sample');
            const line_numbers = $(`<div class="line-numbers">`);
            const source_codes = $(`<div class="source-code">`);
            line_numbers.appendTo(code_elem);
            source_codes.appendTo(code_elem);
            const lines = this.lines.map(x => ({
                content: x.content,
                tokens: x.tokens.map(x => ({ color: x.color, range: [x.range[0], x.range[1]] })),
                attachments: {}
            }));
            for (const formatter of Code.formatters) {
                for (const line of lines) {
                    formatter.preprocess_line(line);
                }
            }
            for (const formatter of Code.formatters) {
                formatter.process_set(lines, set);
            }
            let toggles_per_keyframe = set.map(x => []);
            for (const formatter of Code.formatters) {
                const result = formatter.render(lines, set);
                if (!result) {
                    continue;
                }
                assert(result.length === set.length, 'incorrect toggles length returned from formatter');
                for (let i = 0; i < set.length; i++) {
                    toggles_per_keyframe[i] = toggles_per_keyframe[i].concat(result[i]);
                }
            }
            for (const line of lines) {
                let skip = !line.ever_visible;
                for (const line_number of line.line_number) {
                    if (skip) {
                        skip = false;
                        continue;
                    }
                    line_number.appendTo(line_numbers);
                }
                skip = !line.ever_visible;
                for (const source_code of line.source_code) {
                    if (skip) {
                        skip = false;
                        continue;
                    }
                    source_code.appendTo(source_codes);
                }
            }
            const keyframes = toggles_per_keyframe.map(toggles => {
                function toggle_function() {
                    for (const toggle of toggles) {
                        toggle.toggleClass('collapse');
                    }
                }
                return {
                    apply: toggle_function,
                    undo: toggle_function
                };
            });
            keyframes[0].apply();
            return {
                frame_offset: frame_offset,
                keyframes: keyframes.slice(1)
            };
        }
    }
    Code.formatters = [];
    CodeSample.Code = Code;
    CodeSample.load_code_sample = memoize(source => http_get(`content/code/${source}.json`)
        .then(str => {
        const code = JSON.parse(str);
        return new Code(code);
    }));
    function slide_module(slide_element) {
        return Promise.all(map(slide_element.find('code[data-source]'), $)
            .map(elem => CodeSample.load_code_sample(elem.data('source'))
            .then(data => ({
            element: elem,
            renderer: data
        }))));
    }
    Slides.modules.push(slide_module);
})(CodeSample || (CodeSample = {}));
//# sourceMappingURL=code_sample.js.map