var Fade;
(function (Fade) {
    const fade_renderer = {
        render: function (element) {
            const toggle_function = function () {
                element.toggleClass('fade-visible');
            };
            const keyframe = {
                apply: toggle_function,
                undo: toggle_function
            };
            element.addClass('fade-target');
            const attr = element.attr('data-fade');
            const indices = [];
            for (const match of regex_execs(/(?:;\s*)?(\d+)(?:-(\d+))?/g, attr)) {
                const index = parseInt(match[1], 10);
                indices.push(index);
            }
            const keyframes = [];
            let min = 0;
            if (indices.length !== 0) {
                min = Math.min(...indices);
                for (const key in indices) {
                    keyframes[indices[key] - min] = keyframe;
                }
            }
            return {
                frame_offset: min,
                keyframes: keyframes
            };
        }
    };
    Slides.modules.push(function (element) {
        return Promise.resolve(map(element.find('*[data-fade]'), $)
            .map(function (e) {
            return {
                element: e,
                renderer: fade_renderer
            };
        }));
    });
})(Fade || (Fade = {}));
//# sourceMappingURL=fade.js.map