var Hide;
(function (Hide) {
    const hide_renderer = {
        render: function (element) {
            const toggle_function = function () {
                element.toggleClass('hide-hidden');
            };
            const keyframe = {
                apply: toggle_function,
                undo: toggle_function
            };
            element.addClass('hide-target').addClass('hide-hidden');
            const attr = element.attr('data-hide');
            const indices = [];
            for (const match of regex_execs(/(?:;\s*)?(\d+)(?:-(\d+))?/g, attr)) {
                const index = parseInt(match[1], 10);
                indices.push(index);
            }
            if (indices.length !== 0 && indices[0] === 0) {
                indices.splice(0, 1);
                element.removeClass('hide-hidden');
            }
            const keyframes = [];
            let min = 0;
            if (indices.length !== 0) {
                min = Math.min(...indices);
                for (const key in indices) {
                    keyframes[indices[key] - min] = keyframe;
                }
            }
            return {
                frame_offset: min,
                keyframes: keyframes
            };
        }
    };
    Slides.modules.push(function (element) {
        return Promise.resolve(map(element.find('*[data-hide]'), $)
            .map(function (e) {
            return {
                element: e,
                renderer: hide_renderer
            };
        }));
    });
})(Hide || (Hide = {}));
//# sourceMappingURL=hide.js.map