const BUNDLE_DATA = {
	"content/10_introduction.html": "<section data-footnote=\"Introduction\">\r\n    <article class=\"intermediate\">\r\n        <h1>Modern C++: Metaprogramming</h1>\r\n        <h2>A series of workshops covering modern features of C++</h2>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Series overview</h1>\r\n        <p>4 workshops:</p>\r\n        <ul>\r\n            <li>Fundamentals</li>\r\n            <li>Templates</li>\r\n            <li>Move semantics &amp; rvalue references</li>\r\n            <li><em>Metaprogramming</em></li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Agenda</h1>\r\n        <ol>\r\n            <li data-fade=\"0\">Building a system for console variable.</li>\r\n            <li data-fade=\"1\">Techniques for metaprogramming.</li>\r\n            <li data-fade=\"2\">Particle System with metaprogramming.</li>\r\n            <li data-fade=\"3\">Exercise.</li>\r\n        </ol>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Before we start</h1>\r\n        <p data-fade=\"0\"><em>Get latest version of Visual Studio 2017!</em></p>\r\n        <p data-fade=\"1\">\r\n            Contact information:\r\n            <table data-fade=\"1\">\r\n                <tr>\r\n                    <th>E-mail</th>\r\n                    <td>143042@nhtv.nl</td>\r\n                </tr>\r\n                <tr>\r\n                    <th>Slack</th>\r\n                    <td>Caspar143042</td>\r\n                </tr>\r\n                <tr>\r\n                    <th>Discord</th>\r\n                    <td>Aidiakapi#2177</td>\r\n                </tr>\r\n            </table>\r\n        </p>\r\n        <p data-fade=\"2\"><em>Please give me feedback!</em> <a href=\"https://goo.gl/forms/zVXOH97o1iyB4qIj1\">https://goo.gl/forms/zVXOH97o1iyB4qIj1</a></p>\r\n    </article>\r\n</section>\r\n",
	"content/20_cvar.html": "<section data-footnote=\"CVars\">\r\n    <article class=\"intermediate\">\r\n        <h1>Console Variables</h1>\r\n        <h2>A system for console variables in games.</h2>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Description</h1>\r\n        <p>Properties:</p>\r\n        <ul>\r\n            <li data-fade=\"0\">Define CVar in any source file.</li>\r\n            <li data-fade=\"1\">Forward declare CVar in header file.</li>\r\n            <li data-fade=\"2\">Store and load from file.</li>\r\n            <li data-fade=\"3\">Change at runtime.</li>\r\n            <li data-fade=\"4\">Be any type.</li>\r\n            <li data-fade=\"5\">Everything global. <em>Generally a bad idea...</em> but fits on slides.</li>\r\n        </ul>\r\n        <p data-fade=\"10\">Example cvar file:</p>\r\n        <code data-source=\"20_cvar_file\" data-fade=\"10\" data-frame-offset=\"11\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Top-down programming</h1>\r\n        <p>Strategy for designing a system. <span data-fade=\"1\">You first write the code that uses it, then implement it.</span></p>\r\n        <code data-source=\"21_top_down_design\" data-fade=\"2\" data-frame-offset=\"3\"></code>\r\n        <p data-fade=\"40\">Let's start with <code>CVAR_DEFINE(...)</code> though.</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Creating <code>CVAR_DEFINE</code></h1>\r\n        <code data-source=\"22_cvar\" data-set=\"cvar_define\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Type erasure</h1>\r\n        <ul>\r\n            <li data-fade=\"0\"><code>CVar&lt;T&gt;</code> is <strong>strongly typed</strong>.</li>\r\n            <li data-fade=\"1\">CVars <em>definitions</em> loaded <strong>runtime</strong>. (Static initialization.)</li>\r\n            <li data-fade=\"2\">Needs to act on <strong>different types</strong> at runtime (<code>CVar&lt;i32&gt; !== CVar&lt;Color&gt;</code>).</li>\r\n            <li data-fade=\"3\">Rephrased: Act on different types through the <strong>same</strong> <em>interface</em>.</li>\r\n            <li data-fade=\"4\">We need <em>polymorphism</em>.</li>\r\n            <li data-fade=\"5\">One possible method: <strong>virtual inheritance</strong>.</li>\r\n            <li data-fade=\"6\">\r\n                Other mechanisms for polymorphism:\r\n                <ul>\r\n                    <li>Function pointers.</li>\r\n                    <li><abbr title=\"Curiously Recurring Template Pattern\">CRTP</abbr> (static polymorphism/monomorphism).</li>\r\n                </ul>\r\n            </li>\r\n            <li data-fade=\"7\">We can use <strong>polymorphism</strong> to get <em>type erasure</em>.</li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>The interface</h1>\r\n        <code data-source=\"22_cvar\" data-set=\"interface\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1><code>ConsoleParser&lt;T&gt;</code></h1>\r\n        <code data-source=\"23_parser\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Overview</h1>\r\n        <p>What we have so far:</p>\r\n        <ul>\r\n            <li data-fade=\"0\"><code>CVAR_DEFINE</code> macro to define a CVar.</li>\r\n            <li data-fade=\"1\"><code>CVarBase</code> class for type erasure.</li>\r\n            <li data-fade=\"2\"><code>ConsoleParser&lt;T&gt;</code> which can parse basic types and colors.</li>\r\n            <li data-fade=\"3\"><code>reset_cvars</code>, <code>save_cvars</code>, <code>load_cvars</code>, <code>detail::register_cvar</code> functions.</li>\r\n        </ul>\r\n        <p data-fade=\"10\">What is needed:</p>\r\n        <ul>\r\n            <li data-fade=\"10\">Implement functions.</li>\r\n            <li data-fade=\"11\">Load/store from/to filesystem.</li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1><code>register_cvar</code></h1>\r\n        <code data-source=\"24_cvar_source\" data-set=\"register_cvar\"></code>\r\n        <p data-fade=\"0,6\" data-hide=\"0,10\">What to store the CVars in? <span data-fade=\"1\"><code>std::multimap</code></span></p>\r\n        <p data-fade=\"5,6\" data-hide=\"0,10\">Where to store them? Cannot access globals.</p>\r\n        <p data-fade=\"30\">Next up <code>save_cvars</code>!</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1><code>save_cvars</code></h1>\r\n        <code data-source=\"24_cvar_source\" data-set=\"save_cvars\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1><code>reset_cvars</code></h1>\r\n        <code data-source=\"24_cvar_source\" data-set=\"reset_cvars\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1><code>load_cvars</code></h1>\r\n        <code data-source=\"24_cvar_source\" data-set=\"load_cvars\"></code>\r\n        <p data-fade=\"30\">Long &amp; ugly, but good enough for this.</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>File IO</h1>\r\n        <code data-source=\"25_file_io\"></code>\r\n    </article>\r\n\r\n    <article class=\"intermediate-minor\">\r\n        <h1>Demo</h1>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Extending the system</h1>\r\n        <p>Possible extensions:</p>\r\n        <ul>\r\n            <li data-fade=\"0\">Add validation on parameters.</li>\r\n            <li data-fade=\"1\">Custom getter/setter functions.</li>\r\n            <li data-fade=\"2\">Events on changes.</li>\r\n            <li data-fade=\"3\">File system monitoring.</li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>CVar validation design</h1>\r\n        <code data-source=\"21_top_down_design\" data-set=\"validation\"></code>\r\n        <p data-fade=\"10\"><code>CVAR_DEFINE</code> needs to take optional parameters, <code>CVAR_VALIDATE</code> needs to be created.</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>CVar validation macros</h1>\r\n        <code data-source=\"22_cvar\" data-set=\"validation\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>CVar validation interface</h1>\r\n        <code data-source=\"22_cvar\" data-set=\"validation_interface\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>CVar validation loading</h1>\r\n        <code data-source=\"24_cvar_source\" data-set=\"validation\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Summary</h1>\r\n        <p>What's covered:</p>\r\n        <ul>\r\n            <li data-fade=\"0\">Variadic macros.</li>\r\n            <li data-fade=\"1\">Tag types.</li>\r\n            <li data-fade=\"2\">Static initialization.</li>\r\n            <li data-fade=\"3\">Virtual inheritance (polymorphism) for type erasure.</li>\r\n            <li data-fade=\"4\">Full (explicit) specialization.</li>\r\n            <li data-fade=\"5\">Function pointers.</li>\r\n            <li data-fade=\"6\">Top-down programming.</li>\r\n        </ul>\r\n        <p data-fade=\"10\">Potential improvements:</p>\r\n        <ul>\r\n            <li data-fade=\"10\">Don't use global variables.</li>\r\n            <li data-fade=\"11\">Better serialization (notably string handling).</li>\r\n            <li data-fade=\"12\">More features.</li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Bonus slide: <code>trigger_warning</code></h1>\r\n        <code data-source=\"24_cvar_source\" data-set=\"trigger_warning\"></code>\r\n    </article>\r\n</section>\r\n",
	"content/30_techniques.html": "<section data-footnote=\"Techniques\">\r\n    <article class=\"intermediate\">\r\n        <h1>Techniques</h1>\r\n        <h2>Commonly used techniques for metaprogramming</h2>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Type Traits</h1>\r\n        <p>Metaprogramming often involves manipulation of types. Type traits can help.</p>\r\n        <code data-source=\"30_traits\" data-fade=\"1\" data-frame-offset=\"2\"></code>\r\n        <p data-fade=\"50\">These are just examples, there are <em>74</em> operations in the type traits header.</p>\r\n        <p data-fade=\"51\"><code>x_t<...> === typename x<...>::type</code></p>\r\n        <p data-fade=\"51\"><code>x_v<...> ===&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;x<...>::value</code></p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>SFINAE</h1>\r\n        <p><strong>S</strong>ubstitution <strong>F</strong>ailure <strong>I</strong>s <strong>N</strong>ot <strong>A</strong>n <strong>E</strong>rror. <span data-fade=\"0\">Bread and butter of metaprogramming.</span></p>\r\n        <code data-source=\"31_sfinae\" data-fade=\"1\" data-frame-offset=\"2\"></code>\r\n        <p data-fade=\"50\">Could have used <code>std::size_t = sizeof(T::x)</code> instead of <code>decltype</code>.</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1><code>std::enable_if</code></h1>\r\n        <code data-source=\"32_enable_if\"></code>\r\n        <p data-fade=\"40\"><code>std::enable_if</code> \"enables\" an overload if the condition is met.</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Implementation of <code>std::enable_if</code></h1>\r\n        <p>How to write <code>std::enable_if</code>?</p>\r\n        <code data-source=\"33_enable_if_impl\" data-fade=\"0\" data-frame-offset=\"1\"></code>\r\n        <p data-fade=\"6\">Simply: if condition is true, public alias <code>type</code> with the return value.</p>\r\n        <p data-fade=\"8\">If condition is <em>false</em>, attempt to access <code>type</code>, which does not exist. Error!</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Creating your own traits</h1>\r\n        <code data-source=\"34_writing_traits\"></code>\r\n        <p data-fade=\"19\">You can use SFINAE in partial specialization's type deduction.</p>\r\n    </article>\r\n    \r\n    <article class=\"intermediate-minor\">\r\n        <h1>Break</h1>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Policy based design</h1>\r\n        <code data-source=\"35_policy\"></code>\r\n        <p data-fade=\"50\">Uses of policy design in the standard:</p>\r\n        <ul>\r\n            <li data-fade=\"51\">Allocators on collections (<code>std::vector</code>)</li>\r\n            <li data-fade=\"52\">Deleter on <code>std::unique_ptr</code></li>\r\n            <li data-fade=\"53\">Hash and equality functions on <code>std::unordered_map</code></li>\r\n            <li data-fade=\"54\">Comparison function on <code>std::map</code></li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Type list</h1>\r\n        <code data-source=\"36_type_list\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Summary</h1>\r\n        <p>Covered:</p>\r\n        <ul>\r\n            <li data-fade=\"0\">Traits are a way extracting or injecting information into or from types.</li>\r\n            <li data-fade=\"1\">SFINAE can be used to enable overloads/specializations on arbitrary conditions.</li>\r\n            <li data-fade=\"2\">The standard only provides most generic traits, but you can write you own!</li>\r\n            <li data-fade=\"3\">Use policy based design to make your classes more generic.</li>\r\n            <li data-fade=\"4\">You can write powerful utilities for working with types.</li>\r\n        </ul>\r\n        <p data-fade=\"10\">Guidelines:</p>\r\n        <ul>\r\n            <li data-fade=\"10\">Use template metaprogramming only when you really need to.<sup><a href=\"https://isocpp.github.io/CppCoreGuidelines/CppCoreGuidelines#t120-use-template-metaprogramming-only-when-you-really-need-to\">[T.120]</a></sup></li>\r\n            <li data-fade=\"11\">Use an existing library.<sup><a href=\"https://isocpp.github.io/CppCoreGuidelines/CppCoreGuidelines#t125-if-you-need-to-go-beyond-the-standard-library-tmp-facilities-use-an-existing-library\">[T.125]</a></sup></li>\r\n            <li data-fade=\"12\">Measure your compile-times!</li>\r\n            <li data-fade=\"13\">Use <code>static_assert</code> where reasonably possible!</li>\r\n        </ul>\r\n    </article>\r\n</section>\r\n",
	"content/40_dimensional_analysis.html": "<section data-footnote=\"Dimensional Analysis\">\r\n    <article class=\"intermediate\">\r\n        <h1>Dimensional Analysis</h1>\r\n        <h2>Easier than it sounds</h2>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>What is it?</h1>\r\n        <p>A way to prevent mistakes like: <code>float acceleration = distance / time;</code></p>\r\n        <p data-fade=\"0\"><span data-math>velocity=12\\frac{m}{s}</span></p>\r\n        <ul>\r\n            <li data-fade=\"1\">12 is the quantity.</li>\r\n            <li data-fade=\"2\"><span data-math>\\frac{m}{s}</span> is the unit.</li>\r\n            <li data-fade=\"3\"><span data-math>\\frac{distance}{time}</span> is the dimension.</li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Exponents</h1>\r\n        <p>Some basic math revisited:</p>\r\n        <ul>\r\n            <li data-fade=\"0\"><span data-math>x^a x^b = x^{a+b}</span></li>\r\n            <li data-fade=\"1\"><span data-math>\\frac{x^a}{x^b} = x^{a-b}</span></li>\r\n            <li data-fade=\"2\"><span data-math>x^0 = 1</span></li>\r\n            <li data-fade=\"3\"><span data-math>\\frac{length}{time}=length^1 \\cdot time^{-1}=velocity</span></li>\r\n            <li data-fade=\"4\"><span data-math>\\frac{velocity}{time}=\\frac{length \\cdot time^{-1}}{time}=length^1 \\cdot time^{-2}=acceleration</span></li>\r\n            <li data-fade=\"5\"><span data-math>mass \\cdot acceleration = mass^{1} \\cdot length^{1} \\cdot time^{-2}=force</span></li>\r\n        </ul>\r\n        <p data-fade=\"10\">Multiplying two dimensions adds exponents, dividing subtracts them.</p>\r\n    </article>\r\n</section>",
	"content/50_exercise.html": "<section data-footnote=\"Particles\">\r\n    <article class=\"intermediate\">\r\n        <h1>Particles</h1>\r\n        <h2>Particle types at compile time</h2>\r\n    </article>\r\n\r\n    <article class=\"intermediate-minor\">\r\n        <h1>Demo</h1>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Representing a particle and particle type</h1>\r\n        <code data-source=\"50_particle_type\" data-set=\"representation\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Creating particle types and a particle system</h1>\r\n        <code data-source=\"50_particle_type\" data-set=\"system\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Particle system interface</h1>\r\n        <code data-source=\"51_particle_system_interface\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Implementing the API</h1>\r\n        <code data-source=\"52_particle_system\" data-set=\"api\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Descriptions</h1>\r\n        <code data-source=\"52_particle_system\" data-set=\"descriptions\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Particle system implementation</h1>\r\n        <code data-source=\"52_particle_system\" data-set=\"particle_system\"></code>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Emitter implementations</h1>\r\n        <code data-source=\"52_particle_system\" data-set=\"emitters\"></code>\r\n        <p data-fade=\"50\">And that's all for particle systems and emitters!</p>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>Summary</h1>\r\n        <p>Implemented:</p>\r\n        <ul>\r\n            <li data-fade=\"0\">Compile-time <em>description</em> object of: <strong>particles</strong>, <strong>emitters</strong> and <strong>particle systems</strong>.</li>\r\n            <li data-fade=\"1\">Runtime <em>instantiation</em> of their counterparts.</li>\r\n            <li data-fade=\"2\">Simulation and rendering of particles.</li>\r\n            <li data-fade=\"3\">Using <code>std::tuple</code>.</li>\r\n            <li data-fade=\"4\">More type erasure.</li>\r\n            <li data-fade=\"5\">Functions as parameters.</li>\r\n        </ul>\r\n    </article>\r\n\r\n    <article>\r\n        <h1>How about the rest?</h1>\r\n        <code data-source=\"53_exercise\"></code>\r\n        <p data-fade=\"10\">Implementing this is <em>exercise</em>.</p>\r\n        <p data-fade=\"11\">All the techniques required to implement it are in the slides.</p>\r\n        <p data-fade=\"12\">Make it easier by doing a bit of upfront planning.</p>\r\n    </article>\r\n</section>\r\n",
	"content/60_end.html": "<section>\r\n    <article class=\"intermediate\">\r\n        <h1>Thanks for attending</h1>\r\n        <h2>Questions?</h2>\r\n    </article>\r\n    <article>\r\n        <h1>Contact</h1>\r\n        <p>Feel free to contact me if you have questions later on.</p>\r\n        <table>\r\n            <tr>\r\n                <th>E-mail</th>\r\n                <td>143042@nhtv.nl</td>\r\n            </tr>\r\n            <tr>\r\n                <th>Slack</th>\r\n                <td>Caspar143042</td>\r\n            </tr>\r\n            <tr>\r\n                <th>Discord</th>\r\n                <td>Aidiakapi#2177</td>\r\n            </tr>\r\n        </table>\r\n\r\n        <p><em>Please give me feedback!</em> <a href=\"https://goo.gl/forms/zVXOH97o1iyB4qIj1\">https://goo.gl/forms/zVXOH97o1iyB4qIj1</a></p>\r\n    </article>\r\n</section>\r\n",
	"content/slides.json": "[\r\n    \"10_introduction\",\r\n    \"20_cvar\",\r\n    \"30_techniques\",\r\n    \"50_exercise\",\r\n    \"60_end\"\r\n]\r\n",
	"content/code/20_cvar_file.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,8]],\r\n            [\"sm\", [1,1,7], [5,1,7]],\r\n            [\"sm\", [2,0,15], [3,0,15], [6,0,5], [7,0,6], [8,0,10]],\r\n            [\"sm\", [2,16,25], [3,16,25], [6,6,9], [7,7,10], [8,11,12]],\r\n            [\"cm\"],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"[Colors]\",\r\n        \"BackgroundColor=#ff3e1a27\",\r\n        \"ForegroundColor=#ff00ffff\",\r\n        \"\",\r\n        \"[Window]\",\r\n        \"Width=400\",\r\n        \"Height=300\",\r\n        \"ScalePower=2\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#d38569\", 8 ],\r\n        [ \"#b98eb2\", 15, \"#ffffff\", 10 ],\r\n        [ \"#b98eb2\", 15, \"#ffffff\", 10 ],\r\n        [  ],\r\n        [ \"#d38569\", 8 ],\r\n        [ \"#b98eb2\", 5, \"#ffffff\", 4 ],\r\n        [ \"#b98eb2\", 6, \"#ffffff\", 4 ],\r\n        [ \"#b98eb2\", 10, \"#ffffff\", 2 ]\r\n    ]\r\n}",
	"content/code/21_top_down_design.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", 3, \"hc\", [3,51,81], [4,51,81], [5,58,59], [50,0,4], [51,0,4], [52,0,4]],\r\n            [\"sm\", [3,12,15], \"sn\", [3,12,\"type\"]],\r\n            [\"sm\", [3,17,29], \"sn\", [3,19,\"C++ name\"]],\r\n            [\"sm\", [3,32,38], \"sn\", [3,28,\"Stored category\"]],\r\n            [\"sm\", [3,40,45], \"sn\", [3,37,\"Stored name\"]],\r\n            [\"sm\", [3,48,51], \"sn\", [3,43,\"Default value\"]],\r\n            [\"cn\", \"cm\", \"sl\", [4,5]],\r\n            [\"sl\", [9,10]],\r\n            [\"sm\", [10,12,17], \"sn\", [10,10,\"Custom type\"]],\r\n            [\"cn\", \"cm\"],\r\n            [\"sl\", [11,18], 44],\r\n            [\"sm\", [16,30,80]],\r\n            [\"sn\", [16,30,\"operator* accesses cvar value\"]],\r\n            [\"cm\", \"cn\", \"sl\", [19,24]],\r\n            [\"sm\", [9,19,35], [22,21,38]],\r\n            [\"sm\", [10,19,35], [23,49,66]],\r\n            [\"cm\"],\r\n            [\"hl\", [3,44], \"sl\", [46,47], [59,60]],\r\n            [\"sl\", [50,52]],\r\n            [\"sm\", [50,4,27]],\r\n            [\"sm\", [51,4,26]],\r\n            [\"sm\", [52,4,25]],\r\n            [\"cm\"],\r\n            [\"sl\", [48,49], [53,55], 58, \"sc\", [50,0,4], [51,0,4], [52,0,4]],\r\n            [\"sl\", [56,57]],\r\n            null\r\n        ],\r\n        \"validation\": [\r\n            [\"sl\", [3,5], [9,10], \"hc\", [3,51,81], [4,51,81], [5,58,59]],\r\n            [\"sl\", [6,8], \"hc\", [5,59,61], \"sc\", [5,58,59]],\r\n            [\"sm\", [6,4,18], [6,78,79]],\r\n            [\"sm\", [6,18,41]],\r\n            [\"sm\", [6,42,78]],\r\n            [\"cm\", \"sl\", [1,2]],\r\n            [\"sc\", [3,51,81], [4,51,81]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"bool validate_size(const i32& s) noexcept { return s >= 128; }\",\r\n        \"\",\r\n        \"CVAR_DEFINE(i32, window_width,  Window, Width,  128, CVAR_VALIDATE(validate_size));\",\r\n        \"CVAR_DEFINE(i32, window_height, Window, Height, 128, CVAR_VALIDATE(validate_size));\",\r\n        \"CVAR_DEFINE(i32, window_scale_power, Window, ScalePower, 3,);\",\r\n        \"    CVAR_VALIDATE([](auto value) noexcept { return value >= 0 && value <= 3; })\",\r\n        \");\",\r\n        \"\",\r\n        \"CVAR_DEFINE(Color, background_color, Colors, BackgroundColor, { 0, 0, 128 });\",\r\n        \"CVAR_DEFINE(Color, foreground_color, Colors, ForegroundColor, { 255, 0, 0 });\",\r\n        \"\",\r\n        \"class CvarGame : public Game\",\r\n        \"{\",\r\n        \"public:\",\r\n        \"    CvarGame() :\",\r\n        \"        Game{ \\\"Cvar example\\\", *window_width, *window_height, *window_scale_power }\",\r\n        \"    {\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    void update(Surface& screen, TimeSpan const /*delta_time*/) override\",\r\n        \"    {\",\r\n        \"        screen.clear(*background_color);\",\r\n        \"        screen.draw_text(\\\"Hello World!\\\", 10, 10, *foreground_color);\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    void on_key_down(Key const key, Modifiers /*modifiers*/, bool /*repeat*/) override\",\r\n        \"    {\",\r\n        \"        switch (key)\",\r\n        \"        {\",\r\n        \"        case Key::Escape:\",\r\n        \"            exit();\",\r\n        \"            return;\",\r\n        \"        case Key::F1:\",\r\n        \"            console::reset_cvars();\",\r\n        \"            save_cvars_to_file();\",\r\n        \"            break;\",\r\n        \"        case Key::F2:\",\r\n        \"            load_cvars_from_file();\",\r\n        \"            break;\",\r\n        \"        default: return;\",\r\n        \"        }\",\r\n        \"        resize(*window_width, *window_height, *window_scale_power);\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"int main()\",\r\n        \"{\",\r\n        \"    try\",\r\n        \"    {\",\r\n        \"        load_cvars_from_file();\",\r\n        \"        Game::run(CvarGame{});\",\r\n        \"        save_cvars_to_file();\",\r\n        \"    }\",\r\n        \"    catch (std::exception const& ex)\",\r\n        \"    {\",\r\n        \"        std::cerr << \\\"Error while running game:\\\\n\\\" << ex.what() << \\\"\\\\n\\\";\",\r\n        \"        return -1;\",\r\n        \"    }\",\r\n        \"    return 0;\",\r\n        \"}\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 5, \"#d38569\", 13, \"#cccccc\", 1, \"#b98eb2\", 6, \"#d38569\", 3, \"#cccccc\", 5, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 7, \"#cccccc\", 5, \"#819dc2\", 3, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#d3a969\", 11, \"#cccccc\", 1, \"#d38569\", 3, \"#cccccc\", 17, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#bbbbbb\", 5, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 2, \"#d3a969\", 13, \"#cccccc\", 1, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#d3a969\", 11, \"#cccccc\", 1, \"#d38569\", 3, \"#cccccc\", 17, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#d3a969\", 13, \"#cccccc\", 1, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#d3a969\", 11, \"#cccccc\", 1, \"#d38569\", 3, \"#cccccc\", 22, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#bbbbbb\", 10, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 3 ],\r\n        [ \"#d3a969\", 17, \"#cccccc\", 4, \"#b98eb2\", 5, \"#cccccc\", 7, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 7, \"#cccccc\", 9, \"#819dc2\", 2, \"#cccccc\", 12, \"#819dc2\", 1, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#d3a969\", 11, \"#cccccc\", 1, \"#d38569\", 5, \"#cccccc\", 20, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#bbbbbb\", 15, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#d3a969\", 11, \"#cccccc\", 1, \"#d38569\", 5, \"#cccccc\", 20, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#bbbbbb\", 15, \"#cccccc\", 4, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 2, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 9, \"#cccccc\", 2, \"#b98eb2\", 7, \"#d38569\", 4 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#cccccc\", 1 ],\r\n        [ \"#c8c8c8\", 12, \"#cccccc\", 4 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 2, \"#7da76f\", 14, \"#cccccc\", 54 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 10, \"#d38569\", 9, \"#b98eb2\", 6, \"#91968b\", 14, \"#cccccc\", 2, \"#b98eb2\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 15, \"#c8c8c8\", 5, \"#cccccc\", 20 ],\r\n        [ \"#cccccc\", 15, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#7da76f\", 14, \"#cccccc\", 2, \"#819dc2\", 2, \"#cccccc\", 2, \"#819dc2\", 2, \"#cccccc\", 21 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d38569\", 4, \"#b98eb2\", 6, \"#cccccc\", 5, \"#d38569\", 10, \"#91968b\", 13, \"#cccccc\", 2, \"#b98eb2\", 5, \"#91968b\", 10, \"#cccccc\", 2, \"#b98eb2\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 13, \"#d38569\", 3, \"#cccccc\", 2, \"#b8d7a3\", 6, \"#cccccc\", 1 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 18, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 13, \"#d38569\", 3, \"#cccccc\", 2, \"#b8d7a3\", 2, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 19, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 30, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 13, \"#d38569\", 3, \"#cccccc\", 2, \"#b8d7a3\", 2, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 32, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#c8c8c8\", 14, \"#cccccc\", 53 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 4, \"#d38569\", 4, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 28, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 2, \"#c8c8c8\", 3, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 4 ],\r\n        [ \"#d38569\", 26, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 10, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 10, \"#b98eb2\", 5, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 10, \"#7da76f\", 30, \"#cccccc\", 6, \"#c8c8c8\", 4, \"#cccccc\", 6, \"#7da76f\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ]\r\n    ]\r\n}",
	"content/code/22_cvar.json": "{\r\n    \"sets\": {\r\n        \"cvar_define\": [\r\n            [\"sl\", 116, \"hc\", [44,10,35], [92,40,56], [116,65,70], [117,67,80]],\r\n            [\"sm\", [116,20,65], \"sn\", [116,20,\"Macro parameter list\"]],\r\n            [\"sm\", [116,67,68], \"sn\", [116,66,\"???\",\"question\"]],\r\n            [\"cm\", \"cn\", \"sl\", 117],\r\n            [\"sm\", [117,4,25]],\r\n            [\"sm\", [117,26,34]],\r\n            [\"sm\", [117,34,69]],\r\n            [\"sm\", [117,36,37], [117,47,48], \"sn\", [117,36,\"?          ?\",\"question\"]],\r\n            [\"sn\", [117,17,\"\\\"stringification\\\": turns the parameter into a string\"]],\r\n            [\"cm\", \"sn\", [117,26, \"VAR_NAME{ \\\"Window\\\",  \\\"Width\\\", 128         }\"]],\r\n            [\"cn\", \"sl\", 115],\r\n            [\"sm\", [115,37,43]],\r\n            [\"sm\", [115,44,74], [117,4,34]],\r\n            [\"cm\", \"sn\", [115,8,\"Forward declares a cvar definition\"]],\r\n            [\"cn\", \"sl\", [40,45], [111,114]],\r\n            [\"hl\", [40,42], [112,114]],\r\n            [\"sm\", [43,10,20]],\r\n            [\"cm\", \"sl\", [48,51]],\r\n            [\"sl\", [91,97], 100],\r\n            [\"sl\", [101,102]],\r\n            null\r\n        ],\r\n        \"interface\": [\r\n            [\"sl\", [1,2], 6, 9, \"hc\", [6,53,95], [44,10,35], [92,40,56]],\r\n            [\"sc\", [6,53,95]],\r\n            [\"sl\", [3,4]],\r\n            [\"sl\", [7,8]],\r\n            [\"sl\", 5],\r\n            [\"sl\", [10,12], [17,18], 34, 38],\r\n            [\"sl\", [22,23]],\r\n            [\"sl\", [24,26]],\r\n            [\"sn\", [26,4,\"On failure returns false, otherwise sets value of CVar.\"]],\r\n            [\"cn\", \"sl\", [29,33]],\r\n            [\"hl\", [22,33], \"sl\", [20,21]],\r\n            [\"hl\", [1,38], \"sl\", [40,45], [111,113]],\r\n            [\"sc\", [44,10,35]],\r\n            [\"sl\", [76,79]],\r\n            [\"sm\", [78,15,31], \"sn\", [78,8,\"We'll talk about this soon.\"]],\r\n            [\"cm\", \"cn\", \"sl\", [80,83]],\r\n            [\"sl\", 84],\r\n            [\"sl\", [85,87]],\r\n            [\"hl\", [76,87], \"sl\", [91,97], 100],\r\n            [\"sl\", [11,12], 38],\r\n            [\"sl\", 15],\r\n            [\"sl\", 99],\r\n            null\r\n        ],\r\n        \"validation\": [\r\n            [\"sl\", [116,117], \"hc\", [92,40,56], [116,65,70], [117,67,80], [119,26,76]],\r\n            [\"sc\", [116,65,70]],\r\n            [\"sm\", [116,67,70,\"positive\"], \"sn\", [116,65,\"Called?\",\"question\"]],\r\n            [\"sn\", [116,61,\"Variadic macro\"]],\r\n            [\"cm\", \"cn\"],\r\n            [\"sc\", [117,67,80]],\r\n            [\"sm\", [117,69,80,\"positive\"], \"sn\", [117,62,\"comma separated arguments\"]],\r\n            [\"cn\", \"cm\"],\r\n            [\"sl\", [118,119]],\r\n            [\"sc\", [119,26,76]],\r\n            [\"sm\", [119,26,70]],\r\n            [\"sl\", [11,12], [36,38]],\r\n            [\"hl\", [11,12], [36,38], \"sm\", [119,72,76]],\r\n            [\"cm\", \"sl\", [120,121]],\r\n            [\"sl\", [122,126]],\r\n            [\"hl\", [120,126], \"sl\", [43,45], 111],\r\n            [\"sl\", [91,97], [99,100]],\r\n            [\"sl\", [89,90]],\r\n            [\"sc\", [92,40,56]],\r\n            [\"sm\", [92,42,51], \"sn\", [92,42,\"This is?\",\"question\"]],\r\n            [\"sn\", [92,26,\"Parameter pack of forwarding references\"]],\r\n            [\"hl\", [116,119], \"cm\", \"cn\"],\r\n            [\"sl\", 98],\r\n            [\"sl\", 55],\r\n            [\"sl\", [56,58], 64],\r\n            [\"hl\", [89,100]],\r\n            [\"sm\", [57,19,50]],\r\n            [\"sl\", 46, \"sm\", [57,52,65]],\r\n            [\"sm\", [56,14,30], [57,67,81]],\r\n            [\"cm\", \"sl\", 61, 63],\r\n            [\"sl\", [53,54], \"sm\", [53,15,24], [61,8,17]],\r\n            [\"sm\", [63,8,46]],\r\n            [\"cm\", \"sl\", 59],\r\n            [\"sl\", 60],\r\n            [\"sl\", 62],\r\n            null\r\n        ],\r\n        \"validation_interface\": [\r\n            [\"sl\", [17,26], [28,34]],\r\n            [\"sl\", 27],\r\n            [\"hl\", [17,34], \"sl\", [43,45], [66,67], 75, 111],\r\n            [\"sl\", 68],\r\n            [\"sl\", 69],\r\n            [\"sl\", [70,72]],\r\n            [\"sl\", [73,74]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"namespace console\",\r\n        \"{\",\r\n        \"\",\r\n        \"using LoadWarningFn = void(*)(std::string_view warning);\",\r\n        \"extern void       reset_cvars();\",\r\n        \"extern void        load_cvars(std::string_view source, LoadWarningFn warning_callback = nullptr);\",\r\n        \"extern std::string save_cvars();\",\r\n        \"\",\r\n        \"} // namespace console\",\r\n        \"\",\r\n        \"namespace console::detail\",\r\n        \"{\",\r\n        \"\",\r\n        \"class CVarBase;\",\r\n        \"extern void register_cvar(CVarBase&);\",\r\n        \"\",\r\n        \"class CVarBase\",\r\n        \"{\",\r\n        \"    friend void register_cvar(CVarBase&);\",\r\n        \"    friend void ::console::load_cvars(std::string_view, LoadWarningFn);\",\r\n        \"    friend std::string console::save_cvars();\",\r\n        \"protected:\",\r\n        \"    ~CVarBase() noexcept = default;\",\r\n        \"\",\r\n        \"    virtual std::string serialize()      const          = 0;\",\r\n        \"    virtual bool deserialize(std::string_view) noexcept = 0;\",\r\n        \"    virtual bool validate()                    noexcept = 0;\",\r\n        \"\",\r\n        \"public:\",\r\n        \"    virtual std::string_view category()  const noexcept = 0;\",\r\n        \"    virtual std::string_view name()      const noexcept = 0;\",\r\n        \"\",\r\n        \"    virtual void reset() = 0;\",\r\n        \"};\",\r\n        \"\",\r\n        \"struct cvar_attribute_validate {};\",\r\n        \"\",\r\n        \"} // namespace console::detail\",\r\n        \"\",\r\n        \"namespace console\",\r\n        \"{\",\r\n        \"\",\r\n        \"template <typename T>\",\r\n        \"class CVar final : detail::CVarBase\",\r\n        \"{\",\r\n        \"    using ValidateFn = bool(*)(T const& value);\",\r\n        \"\",\r\n        \"    std::string_view category_;\",\r\n        \"    std::string_view name_;\",\r\n        \"    T default_value_;\",\r\n        \"    T current_value_;\",\r\n        \"\",\r\n        \"    ValidateFn validate_ { nullptr };\",\r\n        \"\",\r\n        \"    static void load_attr() noexcept { }\",\r\n        \"    template <typename... Attr>\",\r\n        \"    void load_attr(detail::cvar_attribute_validate, ValidateFn fn, Attr&&... attr)\",\r\n        \"    {\",\r\n        \"        if (fn == nullptr) { throw std::invalid_argument{ \\\"nullptr validation function\\\" }; }\",\r\n        \"        if (validate_ != nullptr) { throw std::logic_error{ \\\"multiple validation functions\\\" }; }\",\r\n        \"        validate_ = fn;\",\r\n        \"        if (!(*validate_)(default_value_)) { throw std::logic_error{ \\\"invalid default value\\\" }; }\",\r\n        \"        load_attr(std::forward<Attr>(attr)...);\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    bool validate() noexcept override\",\r\n        \"    {\",\r\n        \"        if (validate_ == nullptr ||\",\r\n        \"            (*validate_)(current_value_))\",\r\n        \"        {\",\r\n        \"            return true;\",\r\n        \"        }\",\r\n        \"        current_value_ = default_value_;\",\r\n        \"        return false;\",\r\n        \"    }\",\r\n        \"    std::string serialize() const override\",\r\n        \"    {\",\r\n        \"        return ConsoleParser<T>::serialize(current_value_);\",\r\n        \"    }\",\r\n        \"    bool deserialize(std::string_view in) noexcept override\",\r\n        \"    {\",\r\n        \"        return ConsoleParser<T>::deserialize(current_value_, in);\",\r\n        \"    }\",\r\n        \"    void reset() override { current_value_ = default_value_; }\",\r\n        \"\",\r\n        \"    std::string_view category() const noexcept override { return category_; }\",\r\n        \"    std::string_view name()     const noexcept override { return name_; }\",\r\n        \"\",\r\n        \"public:\",\r\n        \"    template <typename... Attr>\",\r\n        \"    explicit CVar(std::string_view category, std::string_view name,\",\r\n        \"                  T const& default_value, Attr&&... attr) :\",\r\n        \"        category_ { category },\",\r\n        \"        name_     { name },\",\r\n        \"        default_value_ { default_value },\",\r\n        \"        current_value_ { default_value }\",\r\n        \"    {\",\r\n        \"        load_attr(std::forward<Attr>(attr)...);\",\r\n        \"        detail::register_cvar(*this);\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    T const& operator*() const noexcept { return current_value_; }\",\r\n        \"    void set(T value)\",\r\n        \"    {\",\r\n        \"        if (validate_ != nullptr && !(*validate_)(value))\",\r\n        \"        {\",\r\n        \"            throw std::invalid_argument{ \\\"invalid cvar\\\" };\",\r\n        \"        }\",\r\n        \"        current_value_ = value;\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"} // namespace console\",\r\n        \"\",\r\n        \"#define CVAR_DECLARE(TYPE, VAR_NAME) extern ::console::CVar<TYPE> VAR_NAME\",\r\n        \"#define CVAR_DEFINE(TYPE, VAR_NAME, CATEGORY, NAME, DEFAULT_VALUE, ...) \\\\\",\r\n        \"    ::console::CVar<TYPE> VAR_NAME{ #CATEGORY, #NAME, DEFAULT_VALUE, __VA_ARGS__ }\",\r\n        \"\",\r\n        \"#define CVAR_VALIDATE(FN) ::console::detail::cvar_attribute_validate{}, (FN)\",\r\n        \"\",\r\n        \"CVAR_DEFINE(i32, window_width,  Window, Width,  128, CVAR_VALIDATE(validate_size));\",\r\n        \"\",\r\n        \"::console::CVar<i32> window_width{\",\r\n        \"    \\\"Window\\\", \\\"Width\\\", 128,\",\r\n        \"    ::console::detail::cvar_attribute_validate{}, (validate_size)\",\r\n        \"};\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 10, \"#d36971\", 7 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 14, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 4, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 18, \"#d38569\", 11, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 19, \"#d38569\", 10, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 8, \"#d38569\", 14, \"#cccccc\", 19, \"#b98eb2\", 7, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 17, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 20 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"#d36971\", 7, \"#cccccc\", 2, \"#d36971\", 6 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 12, \"#d38569\", 13, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 8 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 16, \"#d38569\", 13, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 16, \"#cccccc\", 2, \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 10, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 11, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 10, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1 ],\r\n        [ \"#c8c8c8\", 13, \"#cccccc\", 3, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 7, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#c8c8c8\", 9, \"#cccccc\", 8, \"#b98eb2\", 15, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 17, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#b98eb2\", 9, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 17, \"#c8c8c8\", 8, \"#cccccc\", 22, \"#b98eb2\", 9, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 12, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#c8c8c8\", 8, \"#cccccc\", 4, \"#b98eb2\", 15, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 12, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#c8c8c8\", 4, \"#cccccc\", 8, \"#b98eb2\", 15, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 17, \"#c8c8c8\", 5, \"#cccccc\", 5, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 24, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 28 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"#d36971\", 7 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 5, \"#b98eb2\", 6, \"#cccccc\", 2, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 8 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 11, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 4, \"#d3a869\", 2, \"#b98eb2\", 5, \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"#e0c0c0\", 9, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"#e0c0c0\", 5, \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 6, \"#e0c0c0\", 14, \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 6, \"#e0c0c0\", 14, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#d38569\", 15, \"#e0c0c0\", 10, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 9, \"#cccccc\", 3, \"#b98eb2\", 9, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 23, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 11 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 7, \"#b98eb2\", 7, \"#cccccc\", 4, \"#b98eb2\", 6, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 2, \"#7da76f\", 30, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 1, \"#e0c0c0\", 10, \"#cccccc\", 3, \"#b98eb2\", 7, \"#cccccc\", 4, \"#b98eb2\", 6, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#7da76f\", 32, \"#cccccc\", 4 ],\r\n        [ \"#e0c0c0\", 18, \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 4, \"#e0c0c0\", 9, \"#cccccc\", 2, \"#e0c0c0\", 14, \"#cccccc\", 5, \"#b98eb2\", 6, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#7da76f\", 24, \"#cccccc\", 4 ],\r\n        [ \"lightgreen\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 1, \"#d3a869\", 4, \"#cccccc\", 12 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 8, \"#cccccc\", 3, \"#b98eb2\", 17 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 1, \"#e0c0c0\", 10, \"#cccccc\", 3, \"#b98eb2\", 8, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 14, \"#e0c0c0\", 9, \"#cccccc\", 2, \"#e0c0c0\", 14, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 23, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#e0c0c0\", 23, \"#cccccc\", 2, \"#e0c0c0\", 14, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 7, \"#c8c8c8\", 9, \"#cccccc\", 3, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 13, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 3, \"lightgreen\", 9, \"#cccccc\", 1, \"#e0c0c0\", 14, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 4, \"#b98eb2\", 17 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 13, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 3, \"lightgreen\", 11, \"#cccccc\", 1, \"#e0c0c0\", 14, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 5, \"#cccccc\", 3, \"#b98eb2\", 9, \"#cccccc\", 2, \"#e0c0c0\", 15, \"#cccccc\", 2, \"#e0c0c0\", 14, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"#c8c8c8\", 8, \"#cccccc\", 3, \"#b98eb2\", 24, \"#cccccc\", 2, \"#b98eb2\", 7, \"#e0c0c0\", 9, \"#cccccc\", 3 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"#c8c8c8\", 4, \"#cccccc\", 7, \"#b98eb2\", 24, \"#cccccc\", 2, \"#b98eb2\", 7, \"#e0c0c0\", 5, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 13, \"#c8c8c8\", 4, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 10, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 5 ],\r\n        [ \"#d3a869\", 20, \"#b98eb2\", 5, \"#cccccc\", 17, \"#d3a869\", 4, \"#cccccc\", 13 ],\r\n        [ \"#e0c0c0\", 18, \"#cccccc\", 13 ],\r\n        [ \"#e0c0c0\", 18, \"#cccccc\", 9 ],\r\n        [ \"#e0c0c0\", 23, \"#cccccc\", 18 ],\r\n        [ \"#e0c0c0\", 23, \"#cccccc\", 17 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"lightgreen\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 1, \"#d3a869\", 4, \"#cccccc\", 12 ],\r\n        [ \"#d36971\", 14, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#d3a869\", 6, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b4b4b4\", 9, \"#cccccc\", 3, \"#b98eb2\", 15, \"#cccccc\", 2, \"#b98eb2\", 7, \"#e0c0c0\", 14, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 3, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 1, \"#e0c0c0\", 10, \"#cccccc\", 3, \"#b98eb2\", 8, \"#cccccc\", 6, \"#e0c0c0\", 9, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 18, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 2, \"#7da76f\", 15, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#e0c0c0\", 23, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 20 ],\r\n        [  ],\r\n        [ \"#9b9b9b\", 8, \"#d3a969\", 12, \"#cccccc\", 1, \"#bbbbbb\", 4, \"#cccccc\", 2, \"#bbbbbb\", 8, \"#cccccc\", 2, \"#b98eb2\", 7, \"#cccccc\", 2, \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1, \"#bbbbbb\", 4, \"#cccccc\", 2, \"#bbbbbb\", 8 ],\r\n        [ \"#9b9b9b\", 8, \"#d3a969\", 11, \"#cccccc\", 1, \"#bbbbbb\", 4, \"#cccccc\", 2, \"#bbbbbb\", 8, \"#cccccc\", 2, \"#bbbbbb\", 8, \"#cccccc\", 2, \"#bbbbbb\", 4, \"#cccccc\", 2, \"#bbbbbb\", 13, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 6, \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1, \"#bbbbbb\", 4, \"#cccccc\", 2, \"#bbbbbb\", 8, \"#cccccc\", 3, \"#bbbbbb\", 8, \"#cccccc\", 3, \"#bbbbbb\", 4, \"#cccccc\", 2, \"#bbbbbb\", 13, \"#cccccc\", 2, \"#bbbbbb\", 12, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#9b9b9b\", 8, \"#d3a969\", 13, \"#cccccc\", 1, \"#bbbbbb\", 2, \"#cccccc\", 4, \"#d36971\", 7, \"#cccccc\", 2, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 23, \"#cccccc\", 5, \"#bbbbbb\", 2, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#d3a969\", 11, \"#cccccc\", 1, \"#d38569\", 3, \"#cccccc\", 17, \"#bbbbbb\", 6, \"#cccccc\", 2, \"#bbbbbb\", 5, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 2, \"#d3a969\", 13, \"#cccccc\", 1, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1, \"#d38569\", 3, \"#cccccc\", 15 ],\r\n        [ \"#7da76f\", 12, \"#cccccc\", 2, \"#7da76f\", 7, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 6, \"#d36971\", 7, \"#cccccc\", 2, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 23, \"#cccccc\", 5, \"#d38569\", 13, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ]\r\n    ]\r\n}",
	"content/code/23_parser.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], 50],\r\n            [\"sl\", [3,6], 27],\r\n            [\"sn\", [6,0,\"Move parsing code out of CVar\"]],\r\n            [\"an\", [6,0,\"Easy specialization\"]],\r\n            [\"cn\", \"sl\", 7, 14],\r\n            [\"sl\", [8,13]],\r\n            [\"hl\", [8,13], \"sl\", [15,26]],\r\n            [\"sm\", [18,8,20]],\r\n            [\"sm\", [19,8,27]],\r\n            [\"sm\", [20,12,21]],\r\n            [\"sm\", [24,8,41]],\r\n            [\"cm\", \"hl\", [15,26]],\r\n            [\"sl\", [28,31], [48,49]],\r\n            [\"sl\", 32, 38, \"sm\", [4,19,20], [7,33,41], [14,28,37], [30,21,30], [32,33,49], [38,28,38]],\r\n            [\"cm\", \"sl\", [33,36]],\r\n            [\"hl\", [33,36], \"sl\", [39,47]],\r\n            [\"sm\", [40,8,12], \"sn\", [40,8,\"std::optional<fw::Color>\"]],\r\n            [\"cm\", \"cn\"],\r\n            [\"hl\", [39,47]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"namespace console\",\r\n        \"{\",\r\n        \"\",\r\n        \"template <typename T>\",\r\n        \"struct ConsoleParser\",\r\n        \"{\",\r\n        \"    static std::string serialize(T const& input)\",\r\n        \"    {\",\r\n        \"        std::stringstream ss;\",\r\n        \"        ss << input;\",\r\n        \"        return ss.str();\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    static bool deserialize(T& output, std::string_view const input)\",\r\n        \"    {\",\r\n        \"        T intermediate{};\",\r\n        \"        std::stringstream ss;\",\r\n        \"        ss << input;\",\r\n        \"        ss >> intermediate;\",\r\n        \"        if (ss.fail())\",\r\n        \"        {\",\r\n        \"            return false;\",\r\n        \"        }\",\r\n        \"        output = std::move(intermediate);\",\r\n        \"        return true;\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <>\",\r\n        \"struct ConsoleParser<fw::Color>\",\r\n        \"{\",\r\n        \"    static std::string serialize(fw::Color const& input)\",\r\n        \"    {\",\r\n        \"        auto hex_str = input.to_hex_string();\",\r\n        \"        return { &hex_str[0] };\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    static bool deserialize(fw::Color& output, std::string_view const input)\",\r\n        \"    {\",\r\n        \"        auto const parse_result = fw::Color::from_hex_string(input);\",\r\n        \"        if (parse_result.has_value())\",\r\n        \"        {\",\r\n        \"            output = *parse_result;\",\r\n        \"            return true;\",\r\n        \"        }\",\r\n        \"        return false;\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"} // namespace console\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 10, \"#d36971\", 7 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 13 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#d3a869\", 2, \"#b98eb2\", 5, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 20 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 3, \"#c8c8c8\", 3, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 10, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#b98eb2\", 6, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d3a869\", 10, \"#cccccc\", 15 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 20 ],\r\n        [ \"#cccccc\", 27 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 4, \"#c8c8c8\", 4, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 24, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 17, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 15 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 13, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 6, \"#b98eb2\", 5, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 16, \"#c8c8c8\", 13, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 11, \"#819dc2\", 1, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 10, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#b98eb2\", 6, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 15, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 2, \"#c8c8c8\", 15, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 14, \"#c8c8c8\", 9, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 35 ],\r\n        [ \"#b98eb2\", 23, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 20 ]\r\n    ]\r\n}",
	"content/code/24_cvar_source.json": "{\r\n    \"sets\": {\r\n        \"register_cvar\": [\r\n            [\"sl\", [117,118], 137],\r\n            [],\r\n            [],\r\n            [\"sl\", 116],\r\n            [\"sn\", [116,3,\"During static initialization, you cannot access any global variables!\",\"warning\"]],\r\n            [\"an\", [116,3,\"They may not yet be initialized.\",\"warning\"]],\r\n            [],\r\n            [\"cn\", \"sl\", 119, \"sm\", [119,16,22]],\r\n            [\"cm\", \"sl\", 7],\r\n            [\"sl\", [14,19], \"sm\", [14,9,15]],\r\n            [\"sm\", [16,4,10], \"sn\", [16,4,\"What does this mean?\",\"question\"]],\r\n            [\"sn\", [16,4,\"Will initialize map the first time this function runs. (Thread safe!)\"]],\r\n            [\"cn\", \"sm\", [19,15,29]],\r\n            [\"cm\", \"hl\", [7,19]],\r\n            [\"sl\", [120,121]],\r\n            [\"sl\", [122,124]],\r\n            [\"sl\", [125,126], 133],\r\n            [\"sl\", [127,128], 132],\r\n            [\"sl\", [129,131]],\r\n            [\"sl\", [134,136]],\r\n            null\r\n        ],\r\n        \"save_cvars\": [\r\n            [\"sl\", [245,246], 271],\r\n            [\"sl\", 247],\r\n            [\"sl\", [248,249]],\r\n            [\"sl\", [250,253]],\r\n            [\"sl\", 254],\r\n            [\"sl\", [255,256], 269],\r\n            [\"sl\", [257,258], 265],\r\n            [\"sl\", [259,262]],\r\n            [\"sl\", [263,264]],\r\n            [\"sl\", [266,268]],\r\n            [\"sm\", [267,34,50]],\r\n            [\"cm\", \"sl\", 270],\r\n            null\r\n        ],\r\n        \"reset_cvars\": [\r\n            [\"sl\", [141,142] ,147],\r\n            [\"sl\", [143,144], 146],\r\n            [\"sl\", 145],\r\n            null\r\n        ],\r\n        \"load_cvars\": [\r\n            [\"sl\", [149,150], 243],\r\n            [\"sl\", 151],\r\n            [\"sl\", [152,154]],\r\n            [\"sl\", [155,157], 242],\r\n            [\"sn\", [157,8,\"Takes the first line from 'source', trims whitespace at the start.\"]],\r\n            [\"cn\", \"sl\", [158,162]],\r\n            [\"hl\", [158,162], \"sl\", [164,166], 182],\r\n            [\"sl\", 167],\r\n            [\"sl\", [168,173]],\r\n            [\"hl\", [168,173], \"sl\", 174],\r\n            [\"sl\", [175,179]],\r\n            [\"sl\", [180,181]],\r\n            [\"hl\", [164,182], \"sl\", [184,185]],\r\n            [\"sl\", [186,190]],\r\n            [\"hl\", [186,190], \"sl\", 191],\r\n            [\"sl\", [192,196]],\r\n            [\"hl\", [192,196], \"sl\", [198,202]],\r\n            [\"hl\", [198,202], \"sl\", [204,211]],\r\n            [\"hl\", [204,211], \"sl\", [213,217], 236],\r\n            [\"hl\", [151,154], 157, [184,185], 191],\r\n            [\"sl\", [218,220], 235],\r\n            [\"sl\", [221,223]],\r\n            [\"sl\", [224,228]],\r\n            [\"sl\", 234],\r\n            [\"hl\", [216,236], \"sl\", [237,241]],\r\n            null\r\n        ],\r\n        \"validation\": [\r\n            [\"sl\", [224,228], \"hc\", [224,0,16], [225,0,16], [226,0,16], [227,0,16], [228,0,16], [229,0,16], [230,0,16], [230,0,16], [231,0,16], [232,0,16], [233,0,16]],\r\n            [\"sl\", [229,230], 233],\r\n            [\"sl\", [231,232]],\r\n            null\r\n        ],\r\n        \"trigger_warning\": [\r\n            [\"sl\", [101,103], 109],\r\n            [\"sl\", 104],\r\n            [\"sl\", 105],\r\n            [\"sl\", [106,107]],\r\n            [\"sm\", [107,4,14], [107,75,76]],\r\n            [\"sm\", [107,15,16], [107,67,68], [107,70,71]],\r\n            [\"sm\", [107,16,34], [107,66,67]],\r\n            [\"sm\", [107,69,70]],\r\n            [\"sm\", [107,71,74]],\r\n            [\"sm\", [107,34,36], [107,40,66]],\r\n            [\"cm\", \"sl\", 108],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"namespace console\",\r\n        \"{\",\r\n        \"\",\r\n        \"namespace\",\r\n        \"{\",\r\n        \"\",\r\n        \"using DataMap = std::multimap<std::string_view, detail::CVarBase*>;\",\r\n        \"\",\r\n        \"// Trick to avoid static initialization order issues.\",\r\n        \"// The data() function will create a DataMap and then\",\r\n        \"// guarantee that it's initialized. It also assigns\",\r\n        \"// the data_ variable. Any code not running during static\",\r\n        \"// initialization can then directly access the DataMap.\",\r\n        \"DataMap& data()\",\r\n        \"{\",\r\n        \"    static DataMap map;\",\r\n        \"    return map;\",\r\n        \"}\",\r\n        \"DataMap const& data_ = data();\",\r\n        \"\",\r\n        \"// Removes the first line from a source string_view\",\r\n        \"// and returns a view to the removed line.\",\r\n        \"std::string_view extract_line(std::string_view& source)\",\r\n        \"{\",\r\n        \"    if (source.empty()) { return {}; }\",\r\n        \"    // Iterate till end or new line character, skipping empty lines\",\r\n        \"    size_t start = 0;\",\r\n        \"    size_t i = 0;\",\r\n        \"    for (; i < source.size(); ++i)\",\r\n        \"    {\",\r\n        \"        auto const c = source[i];\",\r\n        \"        if (c != '\\\\r' && c != '\\\\n') { continue; }\",\r\n        \"        // Ignore newlines at the start of the string\",\r\n        \"        if (start == i)\",\r\n        \"        {\",\r\n        \"            ++start;\",\r\n        \"            continue;\",\r\n        \"        }\",\r\n        \"        break;\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    // start == inclusive start of the extracted string\",\r\n        \"    // i     == exclusive end   of the extracted string\",\r\n        \"\",\r\n        \"    // Iterate till first non-newline character or the end of the\",\r\n        \"    // of the string, this will be what the source is trimmed to.\",\r\n        \"    size_t j = i;\",\r\n        \"    for (; j < source.size(); ++j)\",\r\n        \"    {\",\r\n        \"        auto const c = source[j];\",\r\n        \"        if (c != '\\\\r' && c != '\\\\n') { break; }\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    auto result = source.substr(start, i - start);\",\r\n        \"    source = source.substr(j);\",\r\n        \"    return result;\",\r\n        \"}\",\r\n        \"\",\r\n        \"std::string_view trim_start_whitespace(std::string_view const in)\",\r\n        \"{\",\r\n        \"    for (size_t i = 0; i < in.size(); ++i)\",\r\n        \"    {\",\r\n        \"        auto const c = in[i];\",\r\n        \"        if (c >= 0x20)\",\r\n        \"        {\",\r\n        \"            return in.substr(i);\",\r\n        \"        }\",\r\n        \"    }\",\r\n        \"    return {};\",\r\n        \"}\",\r\n        \"\",\r\n        \"std::string_view trim_end_whitespace(std::string_view const in)\",\r\n        \"{\",\r\n        \"    for (size_t i = in.size(); i != 0; --i)\",\r\n        \"    {\",\r\n        \"        auto const c = in[i - 1];\",\r\n        \"        if (c >= 0x20)\",\r\n        \"        {\",\r\n        \"            return in.substr(0, i);\",\r\n        \"        }\",\r\n        \"    }\",\r\n        \"    return {};\",\r\n        \"}\",\r\n        \"\",\r\n        \"std::string_view trim_whitespace(std::string_view const in)\",\r\n        \"{\",\r\n        \"    return trim_start_whitespace(trim_end_whitespace(in));\",\r\n        \"}\",\r\n        \"\",\r\n        \"struct StringViewPairHash\",\r\n        \"{\",\r\n        \"    using Type = std::pair<std::string_view, std::string_view>;\",\r\n        \"    size_t operator()(Type const& t) const noexcept\",\r\n        \"    {\",\r\n        \"        constexpr auto hasher = std::hash<std::string_view>{};\",\r\n        \"        return hasher(t.first) ^ hasher(t.second);\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"using CVarsSet = std::unordered_set<std::pair<std::string_view, std::string_view>, StringViewPairHash>;\",\r\n        \"\",\r\n        \"template <typename... Args>\",\r\n        \"void trigger_warning(LoadWarningFn warning_fn, Args&&... params)\",\r\n        \"{\",\r\n        \"    if (warning_fn == nullptr) { return; }\",\r\n        \"    std::stringstream ss;\",\r\n        \"    // Invoke operator<< for each parameter\",\r\n        \"    auto _ = { (static_cast<void>(ss << std::forward<Args>(params)), 0)... };\",\r\n        \"    (*warning_fn)(ss.str());\",\r\n        \"}\",\r\n        \"\",\r\n        \"} // namespace\",\r\n        \"\",\r\n        \"namespace detail // console::detail\",\r\n        \"{\",\r\n        \"\",\r\n        \"// WARNING: Runs during static initialization\",\r\n        \"void register_cvar(CVarBase& cvar)\",\r\n        \"{\",\r\n        \"    auto& map = data();\",\r\n        \"    auto const name     = cvar.name();\",\r\n        \"    auto const category = cvar.category();\",\r\n        \"\",\r\n        \"    // Check for duplicate cvars, by iterating over each cvar in the category.\",\r\n        \"    auto const cvars_in_category = map.equal_range(category);\",\r\n        \"    for (auto it = cvars_in_category.first; it != cvars_in_category.second; ++it)\",\r\n        \"    {\",\r\n        \"        if (name == it->second->name())\",\r\n        \"        {\",\r\n        \"            std::stringstream ss;\",\r\n        \"            ss << \\\"duplicate cvar [\\\" << category << \\\"] \\\" << name;\",\r\n        \"            throw std::logic_error{ ss.str() };\",\r\n        \"        }\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    // No duplicate entries, so insert and done\",\r\n        \"    map.insert({ category, &cvar });\",\r\n        \"}\",\r\n        \"\",\r\n        \"} // namespace console::detail\",\r\n        \"\",\r\n        \"void reset_cvars()\",\r\n        \"{\",\r\n        \"    for (auto& pair : data_)\",\r\n        \"    {\",\r\n        \"        pair.second->reset();\",\r\n        \"    }\",\r\n        \"}\",\r\n        \"\",\r\n        \"void load_cvars(std::string_view source, LoadWarningFn const warning_callback)\",\r\n        \"{\",\r\n        \"    if (source.empty()) { return; }\",\r\n        \"\",\r\n        \"    std::string_view current_category{};\",\r\n        \"    CVarsSet loaded_cvars;\",\r\n        \"    do\",\r\n        \"    {\",\r\n        \"        auto line = trim_start_whitespace(extract_line(source));\",\r\n        \"        // Ignore empty lines\",\r\n        \"        if (line.empty()) { continue; }\",\r\n        \"\",\r\n        \"        // Ignore comments\",\r\n        \"        if (line[0] == '#') { continue; }\",\r\n        \"\",\r\n        \"        // Parse category\",\r\n        \"        if (line[0] == '[')\",\r\n        \"        {\",\r\n        \"            line = trim_end_whitespace(line);\",\r\n        \"            if (line.back() != ']')\",\r\n        \"            {\",\r\n        \"                trigger_warning(warning_callback,\",\r\n        \"                    \\\"parsed '[' but line does not end with ']' in line: \\\", line);\",\r\n        \"                continue;\",\r\n        \"            }\",\r\n        \"            auto const category = trim_whitespace(line.substr(1, line.size() - 2));\",\r\n        \"            if (category.empty())\",\r\n        \"            {\",\r\n        \"                trigger_warning(warning_callback, \\\"empty category\\\");\",\r\n        \"                continue;\",\r\n        \"            }\",\r\n        \"            current_category = category;\",\r\n        \"            continue;\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        // Parse cvar key\",\r\n        \"        auto index = line.find_first_of('=');\",\r\n        \"        if (index == std::string_view::npos)\",\r\n        \"        {\",\r\n        \"            trigger_warning(warning_callback, \\\"could not find equal sign in cvar in line: \\\", line);\",\r\n        \"            continue;\",\r\n        \"        }\",\r\n        \"        auto cvar_name = trim_end_whitespace(line.substr(0, index));\",\r\n        \"        if (cvar_name.empty())\",\r\n        \"        {\",\r\n        \"            trigger_warning(warning_callback, \\\"empty cvar name in line: \\\", line);\",\r\n        \"            continue;\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        if (current_category.empty())\",\r\n        \"        {\",\r\n        \"            trigger_warning(warning_callback, \\\"cvar before category in line: \\\", line);\",\r\n        \"            continue;\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        // Prevent duplicate category/name combinations\",\r\n        \"        if (!loaded_cvars.insert({ current_category, cvar_name }).second)\",\r\n        \"        {\",\r\n        \"            trigger_warning(warning_callback,\",\r\n        \"                \\\"cvar [\\\", current_category, \\\"] \\\", cvar_name,\",\r\n        \"                \\\" is defined twice, first definition used\\\");\",\r\n        \"            continue;\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        // Search for the cvar category & name\",\r\n        \"        auto const cvars_in_category = data_.equal_range(current_category);\",\r\n        \"        bool found = false;\",\r\n        \"        for (auto it = cvars_in_category.first; it != cvars_in_category.second; ++it)\",\r\n        \"        {\",\r\n        \"            auto& cvar = *it->second;\",\r\n        \"            if (cvar.name() == cvar_name)\",\r\n        \"            {\",\r\n        \"                found = true;\",\r\n        \"                // Try to load the cvar\",\r\n        \"                auto const cvar_value = line.substr(index + 1);\",\r\n        \"                if (!cvar.deserialize(cvar_value))\",\r\n        \"                {\",\r\n        \"                    trigger_warning(warning_callback,\",\r\n        \"                        \\\"cvar [\\\", current_category, \\\"] \\\", cvar_name, \\\" could not be parsed\\\");\",\r\n        \"                }\",\r\n        \"                else if (!cvar.validate())\",\r\n        \"                {\",\r\n        \"                    trigger_warning(warning_callback,\",\r\n        \"                        \\\"cvar [\\\", current_category, \\\"] \\\", cvar_name, \\\" invalid value\\\");\",\r\n        \"                }\",\r\n        \"                break;\",\r\n        \"            }\",\r\n        \"        }\",\r\n        \"        if (!found)\",\r\n        \"        {\",\r\n        \"            trigger_warning(warning_callback,\",\r\n        \"                \\\"cvar [\\\", current_category, \\\"] \\\", cvar_name, \\\" does not exist\\\");\",\r\n        \"        }\",\r\n        \"    } while (!source.empty());\",\r\n        \"}\",\r\n        \"\",\r\n        \"std::string save_cvars()\",\r\n        \"{\",\r\n        \"    std::stringstream ss;\",\r\n        \"    auto const begin = data_.begin();\",\r\n        \"    auto const end   = data_.end();\",\r\n        \"    if (begin == end)\",\r\n        \"    {\",\r\n        \"        return \\\"\\\";\",\r\n        \"    }\",\r\n        \"    std::string_view current_category{};\",\r\n        \"    for (auto it = begin; it != end; ++it)\",\r\n        \"    {\",\r\n        \"        if (it->first != current_category)\",\r\n        \"        {\",\r\n        \"            if (!current_category.empty())\",\r\n        \"            {\",\r\n        \"                ss << \\\"\\\\n\\\";\",\r\n        \"            }\",\r\n        \"            current_category = it->first;\",\r\n        \"            ss << \\\"[\\\" << current_category << \\\"]\\\\n\\\";\",\r\n        \"        }\",\r\n        \"        auto& cvar = *it->second;\",\r\n        \"        std::string const value = cvar.serialize();\",\r\n        \"        ss << cvar.name() << \\\"=\\\" << value << \\\"\\\\n\\\";\",\r\n        \"    }\",\r\n        \"    return ss.str();\",\r\n        \"}\",\r\n        \"\",\r\n        \"} // namespace console\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 10, \"#d36971\", 7 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 8, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#91968b\", 53 ],\r\n        [ \"#91968b\", 53 ],\r\n        [ \"#91968b\", 51 ],\r\n        [ \"#91968b\", 57 ],\r\n        [ \"#91968b\", 55 ],\r\n        [ \"#d38569\", 7, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d38569\", 8, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 8, \"#b98eb2\", 5, \"#cccccc\", 10, \"#d38569\", 4, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#91968b\", 51 ],\r\n        [ \"#91968b\", 42 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 24, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 8, \"#c8c8c8\", 5, \"#cccccc\", 6, \"#b98eb2\", 7, \"#cccccc\", 5 ],\r\n        [ \"#91968b\", 67 ],\r\n        [ \"#d38569\", 11, \"#cccccc\", 8, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 11, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 14, \"#c8c8c8\", 4, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 14 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#7da76f\", 5, \"#cccccc\", 8, \"#7da76f\", 4, \"#cccccc\", 4, \"#b98eb2\", 8, \"#cccccc\", 3 ],\r\n        [ \"#91968b\", 53 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 12 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 20 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#91968b\", 55 ],\r\n        [ \"#91968b\", 55 ],\r\n        [  ],\r\n        [ \"#91968b\", 65 ],\r\n        [ \"#91968b\", 65 ],\r\n        [ \"#d38569\", 11, \"#cccccc\", 6 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 14, \"#c8c8c8\", 4, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 14 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#7da76f\", 5, \"#cccccc\", 8, \"#7da76f\", 4, \"#cccccc\", 4, \"#b98eb2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 16, \"#c8c8c8\", 6, \"#cccccc\", 19 ],\r\n        [ \"#cccccc\", 20, \"#c8c8c8\", 6, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 33, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#b98eb2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 9, \"#c8c8c8\", 4, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 10 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#819dc2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 3, \"#c8c8c8\", 6, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 31, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#b98eb2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 7, \"#c8c8c8\", 4, \"#cccccc\", 9, \"#819dc2\", 1, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 11, \"#819dc2\", 1, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#819dc2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 3, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 27, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#b98eb2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d38569\", 21, \"#cccccc\", 1, \"#d38569\", 19, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 18 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 11, \"#b4b4b4\", 10, \"#cccccc\", 1, \"#d38569\", 5, \"#b98eb2\", 5, \"#cccccc\", 5, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 23, \"#cccccc\", 9, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 9, \"plum\", 5, \"#cccccc\", 13, \"plum\", 6, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 9, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 3, \"#d38569\", 18, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 15, \"#cccccc\", 1, \"#d38569\", 14, \"#cccccc\", 12, \"#d3a869\", 4, \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 15, \"#b98eb2\", 7, \"#cccccc\", 4, \"#b98eb2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#91968b\", 43 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 7, \"#b98eb2\", 11, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 8, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 1, \"#d3a869\", 4, \"#cccccc\", 12, \"#819dc2\", 1, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 21, \"#c8c8c8\", 3, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 12 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"#d36971\", 7, \"#91968b\", 18 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#91968b\", 45 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 13, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 8, \"#d38569\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 16, \"#c8c8c8\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 16, \"#c8c8c8\", 8, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#91968b\", 78 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 24, \"#c8c8c8\", 11, \"#cccccc\", 11 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 23, \"plum\", 5, \"#cccccc\", 26, \"plum\", 6, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 13, \"plum\", 6, \"#cccccc\", 2, \"#c8c8c8\", 4, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#d36971\", 15, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 18, \"#7da76f\", 19, \"#cccccc\", 15, \"#7da76f\", 5, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 18, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 5, \"#c8c8c8\", 3, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#91968b\", 47 ],\r\n        [ \"#cccccc\", 8, \"#c8c8c8\", 6, \"#cccccc\", 22 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 28 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 11, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 15 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 13, \"plum\", 6, \"#cccccc\", 2, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 10, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 8, \"#d38569\", 14, \"#b98eb2\", 6, \"#cccccc\", 17 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 8, \"#c8c8c8\", 5, \"#cccccc\", 6, \"#b98eb2\", 6, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 19 ],\r\n        [ \"#d38569\", 13, \"#cccccc\", 13 ],\r\n        [ \"#b98eb2\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 7, \"#d38569\", 21, \"#cccccc\", 1, \"#d38569\", 12, \"#cccccc\", 10 ],\r\n        [ \"#91968b\", 29 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#c8c8c8\", 5, \"#cccccc\", 6, \"#b98eb2\", 8, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#91968b\", 26 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#819dc2\", 1, \"#cccccc\", 5, \"#7da76f\", 3, \"#cccccc\", 4, \"#b98eb2\", 8, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#91968b\", 25 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 6, \"#819dc2\", 1, \"#cccccc\", 5, \"#7da76f\", 3, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 19, \"#d38569\", 19, \"#cccccc\", 7 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 6, \"#c8c8c8\", 4, \"#cccccc\", 6, \"#7da76f\", 3, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#d38569\", 31, \"#cccccc\", 18 ],\r\n        [ \"#7da76f\", 73, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 24, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#b98eb2\", 23, \"#cccccc\", 11, \"#d38569\", 15, \"#cccccc\", 6, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 7, \"#c8c8c8\", 4, \"#cccccc\", 5, \"#819dc2\", 1, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 10, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#d38569\", 31, \"#cccccc\", 19, \"#7da76f\", 16, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 24, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 40 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#91968b\", 25 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 13, \"#c8c8c8\", 13, \"#cccccc\", 1, \"#7da76f\", 3, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 10, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#e0c0c0\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#d38569\", 27, \"#cccccc\", 19, \"#7da76f\", 45, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 12, \"#d38569\", 19, \"#cccccc\", 6, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 10 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 11, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#d38569\", 27, \"#cccccc\", 19, \"#7da76f\", 27, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 18, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#d38569\", 27, \"#cccccc\", 19, \"#7da76f\", 32, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#91968b\", 55 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 15, \"#c8c8c8\", 6, \"#cccccc\", 34, \"plum\", 6, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#d38569\", 27, \"#cccccc\", 18 ],\r\n        [ \"#7da76f\", 24, \"#cccccc\", 20, \"#7da76f\", 4, \"#cccccc\", 12 ],\r\n        [ \"#7da76f\", 58, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#91968b\", 46 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 26, \"#c8c8c8\", 11, \"#cccccc\", 19 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 8, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 23, \"plum\", 5, \"#cccccc\", 26, \"plum\", 6, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 16, \"#cccccc\", 14, \"plum\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 6, \"#c8c8c8\", 4, \"#cccccc\", 16 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 24, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#91968b\", 39 ],\r\n        [ \"#b98eb2\", 27, \"#cccccc\", 18, \"#c8c8c8\", 6, \"#cccccc\", 9, \"#819dc2\", 1, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 7, \"#c8c8c8\", 11, \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 17 ],\r\n        [ \"#d38569\", 35, \"#cccccc\", 18 ],\r\n        [ \"#7da76f\", 32, \"#cccccc\", 20, \"#7da76f\", 4, \"#cccccc\", 13, \"#7da76f\", 22, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 17 ],\r\n        [ \"#b98eb2\", 24, \"#cccccc\", 7, \"#c8c8c8\", 8, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 17 ],\r\n        [ \"#d38569\", 35, \"#cccccc\", 18 ],\r\n        [ \"#7da76f\", 32, \"#cccccc\", 20, \"#7da76f\", 4, \"#cccccc\", 13, \"#7da76f\", 16, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 17 ],\r\n        [ \"#b98eb2\", 21, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#d38569\", 27, \"#cccccc\", 18 ],\r\n        [ \"#7da76f\", 24, \"#cccccc\", 20, \"#7da76f\", 4, \"#cccccc\", 13, \"#7da76f\", 17, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 6, \"#b98eb2\", 6, \"#cccccc\", 9, \"#c8c8c8\", 5, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 17, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 14, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 14, \"#c8c8c8\", 3, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#7da76f\", 2, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 19 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 28 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 5, \"plum\", 6, \"#cccccc\", 20 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 19, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 22, \"#7da76f\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 35, \"plum\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 18, \"#7da76f\", 4, \"#cccccc\", 23, \"#7da76f\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 14, \"plum\", 6, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 7, \"#b98eb2\", 6, \"#cccccc\", 13, \"#c8c8c8\", 9, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 19, \"#c8c8c8\", 4, \"#cccccc\", 6, \"#7da76f\", 4, \"#cccccc\", 12, \"#7da76f\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 3, \"#c8c8c8\", 3, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 20 ]\r\n    ]\r\n}",
	"content/code/25_file_io.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], 5],\r\n            [\"sl\", [3,4]],\r\n            [\"sl\", [6,8], 17],\r\n            [\"sl\", 9],\r\n            [\"sl\", [10,12]],\r\n            [\"sl\", [13,16]],\r\n            [\"sm\", [13,40,68], \"sn\", [13,40,\"Is?\",\"question\"]],\r\n            [\"cm\", \"sn\", [13,40,\"Lambda function: void(std::string_view)\"]],\r\n            [\"cn\"],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"void save_cvars_to_file()\",\r\n        \"{\",\r\n        \"    std::ofstream cvar_file{ \\\"cvars\\\" };\",\r\n        \"    cvar_file << console::save_cvars();\",\r\n        \"}\",\r\n        \"\",\r\n        \"void load_cvars_from_file()\",\r\n        \"{\",\r\n        \"    console::reset_cvars();\",\r\n        \"    std::ifstream cvar_file{ \\\"cvars\\\" };\",\r\n        \"    std::stringstream cvar_str;\",\r\n        \"    cvar_str << cvar_file.rdbuf();\",\r\n        \"    console::load_cvars(cvar_str.str(), [](std::string_view warning)\",\r\n        \"    {\",\r\n        \"        std::cout << \\\"warning loading cvars: \\\" << warning << \\\"\\\\n\\\";\",\r\n        \"    });\",\r\n        \"}\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 5, \"#d38569\", 18, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 9, \"#cccccc\", 11, \"#7da76f\", 8, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 17, \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 10, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 20, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 3 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 9, \"#cccccc\", 11, \"#7da76f\", 8, \"#cccccc\", 2 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 26, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 10, \"#cccccc\", 10, \"#c8c8c8\", 3, \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 10, \"#7da76f\", 26, \"#cccccc\", 14, \"#7da76f\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 1 ]\r\n    ]\r\n}",
	"content/code/30_traits.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], \"hc\",\r\n                [4,38,58], [5,38,57], [6,26,58], [7,25,57], [8,49,57],\r\n                [10,22,41], [11,25,41], [12,25,41],\r\n                [14,19,24], [15,19,24], [16,19,24], [17,24,29], [18,24,29], [19,24,29], [20,24,29], [21,24,29], [22,24,29],\r\n                [24,28,47], [25,28,47], [26,28,44], [27,33,44], [28,33,44], [29,33,44]\r\n            ],\r\n            [\"sl\", [3,4]],\r\n            [\"sc\", [4,38,58]],\r\n            [\"sl\", 5],\r\n            [\"sc\", [5,38,57]],\r\n            [\"sl\", 6],\r\n            [\"sc\", [6,26,58]],\r\n            [\"sl\", 7],\r\n            [\"sc\", [7,25,57]],\r\n            [\"sl\", 8],\r\n            [\"sc\", [8,49,57]],\r\n            [\"hl\", [1,9], \"sl\", 10],\r\n            [\"sl\", 11],\r\n            [\"sc\", [11,25,41]],\r\n            [\"sl\", 12],\r\n            [\"sc\", [10,22,41], [12,25,41]],\r\n            [\"sl\", [13,14]],\r\n            [\"sc\", [14,19,24]],\r\n            [\"sl\", 15],\r\n            [\"sc\", [15,19,24]],\r\n            [\"sl\", 16],\r\n            [\"sc\", [16,19,24]],\r\n            [\"sl\", 17],\r\n            [\"sc\", [17,24,29]],\r\n            [\"sl\", 18],\r\n            [\"sc\", [18,24,29]],\r\n            [\"sl\", 19],\r\n            [\"sc\", [19,24,29]],\r\n            [\"sl\", 20],\r\n            [\"sc\", [20,24,29]],\r\n            [\"sl\", 21],\r\n            [\"sc\", [21,24,29]],\r\n            [\"sl\", 22],\r\n            [\"sc\", [22,24,29]],\r\n            [\"sl\", [23,24]],\r\n            [\"sc\", [24,28,47]],\r\n            [\"sl\", 25],\r\n            [\"sc\", [25,28,47]],\r\n            [\"sl\", 26],\r\n            [\"sc\", [26,28,44]],\r\n            [\"sl\", 27],\r\n            [\"sc\", [27,33,44]],\r\n            [\"sl\", 28],\r\n            [\"sc\", [28,33,44]],\r\n            [\"sl\", 29],\r\n            [\"sc\", [29,33,44]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"int add(int a, int b) { return a + b; }\",\r\n        \"using AddPtr = int(*)(int, int);\",\r\n        \"\",\r\n        \"std::is_same_v<decltype( add), AddPtr>            // false\",\r\n        \"std::is_same_v<decltype(&add), AddPtr>            // true\",\r\n        \"std::is_function_v<AddPtr>                        // false\",\r\n        \"std::is_pointer_v<AddPtr>                         // true\",\r\n        \"std::is_function_v<std::remove_pointer_t<AddPtr>> // true\",\r\n        \"\",\r\n        \"using Array1 = int[2];    // int      [2]\",\r\n        \"using Array2 = Array1[3]; // int   [3][2]\",\r\n        \"using Array3 = Array2[5]; // int[5][3][2]\",\r\n        \"\",\r\n        \"std::rank_v<Array1> == 1\",\r\n        \"std::rank_v<Array2> == 2\",\r\n        \"std::rank_v<Array3> == 3\",\r\n        \"std::extent_v<Array1, 0> == 2\",\r\n        \"std::extent_v<Array2, 0> == 3\",\r\n        \"std::extent_v<Array2, 1> == 2\",\r\n        \"std::extent_v<Array3, 0> == 5\",\r\n        \"std::extent_v<Array3, 1> == 3\",\r\n        \"std::extent_v<Array3, 2> == 2\",\r\n        \"\",\r\n        \"std::remove_extent_t<Array3>      // === Array2\",\r\n        \"std::remove_extent_t<Array2>      // === Array1\",\r\n        \"std::remove_extent_t<Array1>      // === int\",\r\n        \"std::remove_all_extents_t<Array3> // === int\",\r\n        \"std::remove_all_extents_t<Array2> // === int\",\r\n        \"std::remove_all_extents_t<Array1> // === int\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 4, \"#d38569\", 3, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 3, \"#b98eb2\", 4, \"#cccccc\", 5, \"#b98eb2\", 7, \"#cccccc\", 8 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 7, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 4, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 3, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 20 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 3, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 19 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 16, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 32 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 15, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 32 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 16, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"#91968b\", 8 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 7, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#91968b\", 19 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 7, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#91968b\", 16 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 7, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#91968b\", 16 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 9, \"#d38569\", 6, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 9, \"#d38569\", 6, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 9, \"#d38569\", 6, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 11, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 11, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 11, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 11, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 11, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 11, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 5, \"#819dc2\", 1 ],\r\n        [  ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 15, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 19 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 15, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 19 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 15, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 16 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 20, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 11 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 20, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 11 ],\r\n        [ \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 20, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 1, \"#91968b\", 11 ]\r\n    ]\r\n}",
	"content/code/31_sfinae.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], \"hc\", [4,20,47], [10,20,47], [10,47,64], [19,21,67], [21,21,48], [21,48,53], [21,53,59], [21,59,73]],\r\n            [\"sl\", [16,17], 22],\r\n            [\"sl\", [18,19]],\r\n            [\"sl\", [3,8]],\r\n            [\"sl\", [20,21]],\r\n            [\"sm\", [21,4,20], \"sn\", [21,4,\"Works?\",\"question\"]],\r\n            [\"sm\", [21,4,20,\"negative\"], \"sn\", [21,4,\"error C2039: 'x': is not a member of 'HasY'\",\"error\"]],\r\n            [\"cm\", \"cn\", \"sl\", [9,15]],\r\n            [\"sn\", [14,0,\"Works?\",\"question\"]],\r\n            [\"sn\", [14,0,\"error C2995: 'void print_xy(const T &)': function template has already been defined\",\"error\"]],\r\n            [\"sn\", [14,0,\"Can you make this work though?\",\"question\"]],\r\n            [\"cn\", \"sc\", [4,20,47]],\r\n            [\"sm\", [4,22,30]],\r\n            [\"sm\", [4,33,47]],\r\n            [\"sm\", [4,42,46]],\r\n            [\"sm\", [19,4,19], \"sn\", [19,4,\"What happens?\",\"question\"]],\r\n            [\"sm\", [5,5,13], \"sn\", [5,5,\"Can this be called?\",\"question\"]],\r\n            [\"cm\", \"sn\", [4,19,\"T deduced to HasX\"]],\r\n            [\"sn\", [4,33,\"decltype(HasX::x) === int\"]],\r\n            [\"sm\", [5,5,13,\"positive\"], \"sn\", [19,4,\"Can call print_xy<HasX, int>(HasX const&)\"]],\r\n            [\"sm\", [11,5,13,\"positive\"], \"an\", [19,4,\"But also print_xy<HasX>(HasX const&)\",\"warning\"]],\r\n            [\"cm\", \"sn\", [19,4,\"error C2668: 'print_xy': ambiguous call to overloaded function\",\"error\"]],\r\n            [\"sm\", [21,4,19], \"sn\", [21,4,\"What happens?\", \"question\"]],\r\n            [\"sm\", [5,5,13], \"sn\", [5,5,\"Can this be called?\",\"question\"]],\r\n            [\"sm\", [4,10,20], \"sn\", [4,19,\"T deduced to HasY\"]],\r\n            [\"sm\", [4,33,47], \"sn\", [4,33,\"This?\",\"question\"]],\r\n            [\"sn\", [4,24,\"Normally decltype(HasY::x) would be a hard error.\"]],\r\n            [\"an\", [4,24,\"But SFINAE kicks in, and discards the overload instead.\"]],\r\n            [\"sm\", [5,5,13,\"negative\"], \"cn\"],\r\n            [\"am\", [11,5,13,\"positive\"], \"sn\", [11,5,\"This can be called just fine.\"]],\r\n            [\"cm\", \"cn\", \"sc\", [21,21,48], [21,59,73]],\r\n            [\"sc\", [10,20,47], [21,48,53]],\r\n            [\"sn\", [14,0,\"Problem solved, right?\",\"question\"]],\r\n            [\"sn\", [14,0,\"error C2995: 'void print_xy(const T &)': function template has already been defined\",\"error\"]],\r\n            [\"an\", [14,0,\"Solutions?\",\"question\"]],\r\n            [\"cn\", \"sc\", [10,47,64], [21,53,59]],\r\n            [\"sm\", [10,49,64]],\r\n            [\"cm\"],\r\n            [\"sc\", [19,21,67]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"struct HasX { int x; };\",\r\n        \"struct HasY { int y; };\",\r\n        \"\",\r\n        \"template <typename T, typename = decltype(T::x)>\",\r\n        \"void print_xy(T const& object)\",\r\n        \"{\",\r\n        \"    std::cout << \\\"x: \\\" << object.x << \\\"\\\\n\\\";\",\r\n        \"}\",\r\n        \"\",\r\n        \"template <typename T, typename = decltype(T::y), typename = void>\",\r\n        \"void print_xy(T const& object)\",\r\n        \"{\",\r\n        \"    std::cout << \\\"y: \\\" << object.y << \\\"\\\\n\\\";\",\r\n        \"}\",\r\n        \"\",\r\n        \"static void example()\",\r\n        \"{\",\r\n        \"    HasX has_x{ 3 };\",\r\n        \"    print_xy(has_x); // calls void print_xy<HasX, int>(HasX const&)\",\r\n        \"    HasY has_y{ 5 };\",\r\n        \"    print_xy(has_y); // calls void print_xy<HasY, int, void>(HasY const&)\",\r\n        \"}\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 7, \"#d38569\", 5, \"#cccccc\", 2, \"#b98eb2\", 4, \"plum\", 1, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 5, \"#cccccc\", 2, \"#b98eb2\", 4, \"plum\", 1, \"#cccccc\", 4 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2, \"lightgreen\", 1, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#b98eb2\", 5, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 10, \"#7da76f\", 6, \"#cccccc\", 10, \"lightgreen\", 2, \"#cccccc\", 3, \"#7da76f\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2, \"lightgreen\", 1, \"#cccccc\", 3, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#b98eb2\", 5, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 10, \"#7da76f\", 6, \"#cccccc\", 10, \"lightgreen\", 2, \"#cccccc\", 3, \"#7da76f\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#d38569\", 7, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 9, \"#cccccc\", 7, \"#819dc2\", 2, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 9, \"#91968b\", 46 ],\r\n        [ \"#d38569\", 9, \"#cccccc\", 7, \"#819dc2\", 2, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 9, \"#91968b\", 52 ],\r\n        [ \"#cccccc\", 1 ]\r\n    ]\r\n}",
	"content/code/32_enable_if.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [15,17], 30, \"hc\", [3,7,53], [3,54,55]],\r\n            [\"sl\", [18,19]],\r\n            [\"sl\", 20],\r\n            [\"sl\", 21],\r\n            [\"sl\", [22,23]],\r\n            [\"sl\", [24,29]],\r\n            [\"sl\", [1,4], 6],\r\n            [\"sm\", [1,19,20], [2,34,35], [2,41,42], [3,7,8]],\r\n            [\"sm\", [2,0,4], [3,4,8]],\r\n            [\"sn\", [3,4,\"Trailing return type, NOT deduced return type.\"]],\r\n            [\"sm\", [2,19,25], \"sn\", [2,19,\"Called?\",\"question\"]],\r\n            [\"sn\", [2,19,\"Forwarding reference (rvalue reference to deduced type)\"]],\r\n            [\"cm\", \"cn\", \"sl\", 5],\r\n            [\"sm\", [5,11,44]],\r\n            [\"sn\", [5,11,\"Will only work for floating points.\"]],\r\n            [\"cm\", \"cn\", \"sc\", [3,7,53], [3,54,55]],\r\n            [\"sm\", [3,7,24], [3,54,55]],\r\n            [\"sm\", [3,24,51], \"sn\", [3,24,\"Condition\"]],\r\n            [\"sm\", [3,53,54], \"sn\", [3,49,\"Return type\"]],\r\n            [\"cm\", \"sn\", [3,0,\"Read as: enable this overload if T is a floating point, with return value T.\"]],\r\n            [\"hl\", [24,29]],\r\n            [\"cn\", \"sl\", [7,14]],\r\n            [\"sm\", [12,11,43]],\r\n            [\"sm\", [10,24,45]],\r\n            [\"cm\"],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"template <typename T, typename REng>\",\r\n        \"auto random_number(REng&& engine, T min, T max)\",\r\n        \"    -> std::enable_if_t<std::is_floating_point_v<T>, T>\",\r\n        \"{\",\r\n        \"    return std::uniform_real_distribution<T>{ min, max }(engine);\",\r\n        \"}\",\r\n        \"\",\r\n        \"template <typename T, typename REng>\",\r\n        \"auto random_number(REng&& engine, T min, T max)\",\r\n        \"    -> std::enable_if_t<std::is_integral_v<T>, T>\",\r\n        \"{\",\r\n        \"    return std::uniform_int_distribution<T>{ min, max }(engine);\",\r\n        \"}\",\r\n        \"\",\r\n        \"static void example()\",\r\n        \"{\",\r\n        \"    std::default_random_engine engine{ 0 };\",\r\n        \"\",\r\n        \"    auto rnd1 = random_number(engine, 0.f, 100.f);\",\r\n        \"    auto rnd2 = random_number(engine, 1, 6);\",\r\n        \"    auto rnd3 = random_number<float>(engine, 0.5, 1.5);\",\r\n        \"    auto rnd4 = random_number<double>(engine, 1, 6);\",\r\n        \"    auto rnd5 = random_number<std::uint32_t>(engine, 42, 420);\",\r\n        \"\",\r\n        \"    static_assert(std::is_same_v<decltype(rnd1), float        >);\",\r\n        \"    static_assert(std::is_same_v<decltype(rnd2), int          >);\",\r\n        \"    static_assert(std::is_same_v<decltype(rnd3), float        >);\",\r\n        \"    static_assert(std::is_same_v<decltype(rnd4), double       >);\",\r\n        \"    static_assert(std::is_same_v<decltype(rnd5), std::uint32_t>);\",\r\n        \"}\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 13, \"#cccccc\", 1, \"#d3a869\", 4, \"#cccccc\", 11, \"#d3a869\", 2, \"#cccccc\", 5, \"#d3a869\", 2, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 22, \"#d3a869\", 1, \"#cccccc\", 3, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 25, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 22 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 13, \"#cccccc\", 1, \"#d3a869\", 4, \"#cccccc\", 11, \"#d3a869\", 2, \"#cccccc\", 5, \"#d3a869\", 2, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 16, \"#d3a869\", 1, \"#cccccc\", 3, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 24, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 22 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#d38569\", 7, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 22, \"#cccccc\", 8, \"#819dc2\", 2, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 7, \"#d38569\", 13, \"#cccccc\", 9, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 7, \"#d38569\", 13, \"#cccccc\", 9, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 7, \"#d38569\", 13, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 10, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 7, \"#d38569\", 13, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 10, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 7, \"#d38569\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 10, \"#819dc2\", 2, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 8, \"#b98eb2\", 13, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 8, \"#b98eb2\", 13, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 8, \"#b98eb2\", 13, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 8, \"#b98eb2\", 13, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 8, \"#cccccc\", 8, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 1 ]\r\n    ]\r\n}",
	"content/code/33_enable_if_impl.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2]],\r\n            [\"sl\", [3,5], 7],\r\n            [\"sm\", [4,7,34]],\r\n            [\"sn\", [4,7,\"Called?\",\"question\"]],\r\n            [\"sn\", [4,7,\"Partial specialization\"]],\r\n            [\"cm\", \"cn\", \"sl\", 6],\r\n            [],\r\n            [\"sl\", [8,10]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"template <bool Condition, typename ReturnType = void>\",\r\n        \"struct enable_if {};\",\r\n        \"template <typename ReturnType>\",\r\n        \"struct enable_if<true, ReturnType>\",\r\n        \"{\",\r\n        \"    using type = ReturnType;\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <bool Condition, typename ReturnType = void>\",\r\n        \"using enable_if_t = typename enable_if<Condition, ReturnType>::type;\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 5, \"#d3a869\", 9, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 11, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 10, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 10, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 9, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 2, \"#d3a869\", 10, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d3a869\", 10, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 5, \"#d3a869\", 9, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 11, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 12, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d38569\", 9, \"#cccccc\", 1, \"#d3a869\", 9, \"#cccccc\", 2, \"#d3a869\", 10, \"#cccccc\", 3, \"lightgreen\", 4, \"#cccccc\", 1 ]\r\n    ]\r\n}",
	"content/code/34_writing_traits.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], \"hc\", [4,20,37], [7,22,24], [7,24,36], [7,36,50], [7,50,51]],\r\n            [\"sl\", [9,10]],\r\n            [\"sl\", [3,5]],\r\n            [\"sl\", [6,8]],\r\n            [\"sc\", [4,20,37]],\r\n            [\"sn\", [10,15,\"has_x<HasY, void>\"]],\r\n            [\"cn\", \"sc\", [7,22,24], [7,36,50]],\r\n            [\"sn\", [7,24,\"Works?\",\"question\"]],\r\n            [\"an\", [7,24,\"decltype(HasX::x) === int\"]],\r\n            [\"an\", [7,24,\"SFINAE part works, but the partial specialization doesn't match\"]],\r\n            [\"cn\", \"sc\", [7,24,36], [7,50,51]],\r\n            [\"sm\", [7,24,36], [7,50,51]],\r\n            [\"cm\"],\r\n            [\"sl\", [17,20]],\r\n            [\"sl\", [11,13]],\r\n            [\"sl\", [14,16]],\r\n            [\"sm\", [15,27,41]],\r\n            [\"cm\", \"sn\", [15,27,\"Works?\",\"question\"]],\r\n            [\"sn\", [15,27,\"Yes!\"]],\r\n            [\"cn\"],\r\n            [],\r\n            [\"sm\", [15,24,41,\"positive\"]],\r\n            [\"sm\", [15,45,49,\"negative\"]],\r\n            [\"sm\", [14,10,20,\"negative\"]],\r\n            [\"cm\"],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"struct HasX { int x; };\",\r\n        \"struct HasY { int y; };\",\r\n        \"\",\r\n        \"template <typename T, typename = void>\",\r\n        \"constexpr bool has_x = false;\",\r\n        \"template <typename T>\",\r\n        \"constexpr bool has_x<T, std::void_t<decltype(T::x)>> = true;\",\r\n        \"\",\r\n        \"static_assert( has_x<HasX>);\",\r\n        \"static_assert(!has_x<HasY>);\",\r\n        \"\",\r\n        \"template <typename T, typename XType>\",\r\n        \"constexpr bool has_x_of = false;\",\r\n        \"template <typename T>\",\r\n        \"constexpr bool has_x_of<T, decltype(T::x)> = true;\",\r\n        \"\",\r\n        \"static_assert( has_x_of<HasX, int  >);\",\r\n        \"static_assert(!has_x_of<HasX, float>);\",\r\n        \"static_assert(!has_x_of<HasY, int  >);\",\r\n        \"static_assert(!has_x_of<HasY, float>);\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 7, \"#d38569\", 5, \"#cccccc\", 2, \"#b98eb2\", 4, \"plum\", 1, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 5, \"#cccccc\", 2, \"#b98eb2\", 4, \"plum\", 1, \"#cccccc\", 4 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 8, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 6, \"#d3a869\", 1, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2, \"lightgreen\", 1, \"#cccccc\", 6, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 8, \"#d38569\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 8, \"#d38569\", 4, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 11, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2, \"lightgreen\", 1, \"#cccccc\", 5, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 11, \"#d38569\", 4, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 11, \"#d38569\", 4, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 11, \"#d38569\", 4, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 11, \"#d38569\", 4, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 3 ]\r\n    ]\r\n}",
	"content/code/35_policy.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,3], \"hc\", [159,22,38]],\r\n            [\"sl\", [4,9], 15],\r\n            [\"sm\", [8,7,52]],\r\n            [\"sm\", [8,24,45]],\r\n            [\"sm\", [8,47,51]],\r\n            [\"cm\"],\r\n            [\"sl\", [16,19], 30],\r\n            [\"sl\", [20,23]],\r\n            [\"hl\", [20,23]],\r\n            [\"hl\", [1,30], \"sl\", [32,36], [44,48], 59],\r\n            [\"sm\", [35,24,51], [47,24,51]],\r\n            [\"cm\", \"sl\", [60,73]],\r\n            [\"hl\", [32,60], [63,73]],\r\n            [\"sl\", [75,80], [157,171], 176],\r\n            [\"hl\", [160,171], \"sc\", [159,22,38]],\r\n            [\"sl\", 173],\r\n            [\"sl\", [174,175]],\r\n            [\"sl\", [81,84], [155,156]],\r\n            [\"sm\", [82,10,38]],\r\n            [\"sm\", [62,7,29], [82,50,74]],\r\n            [\"sm\", [61,0,21], [82,10,29]],\r\n            [\"cm\", \"sl\", [85,90]],\r\n            [\"hl\", [156,176], \"sl\", [91,96]],\r\n            [\"hl\", [61,62], [75,81], [85,96], \"sl\", [99,101], 120],\r\n            [\"sl\", [102,103]],\r\n            [\"sl\", [104,113]],\r\n            [\"sl\", [114,117]],\r\n            [\"sl\", [118,119]],\r\n            [\"hl\", [99,120], \"sl\", [122,125], 154],\r\n            [\"sl\", [126,128]],\r\n            [\"sl\", [129,131]],\r\n            [\"sl\", [132,142]],\r\n            [\"hl\", [132,142], \"sl\", [143,146]],\r\n            [\"sl\", [147,153]],\r\n            [\"hl\", [123,154], \"sl\", 99],\r\n            [\"sl\", [156,159], \"sl\", [173,176]],\r\n            [\"sn\", [176,0,\"What is the point of the policy parameter on MeshSerializer?\",\"question\"]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"static_assert(std::is_same_v<unsigned char, uint8_t>);\",\r\n        \"using Archive = std::vector<uint8_t>;\",\r\n        \"using Size = int_fast32_t;\",\r\n        \"\",\r\n        \"// Handles all integral types\",\r\n        \"template <typename T>\",\r\n        \"auto primitive_serialize(Archive& out, T value)\",\r\n        \"    -> std::enable_if_t<std::is_integral_v<T>, Size>\",\r\n        \"{\",\r\n        \"    for (auto i = 0; i < sizeof(T); ++i)\",\r\n        \"    {\",\r\n        \"        out.push_back(static_cast<uint8_t>(value >> i * 8));\",\r\n        \"    }\",\r\n        \"    return sizeof(T);\",\r\n        \"}\",\r\n        \"template <typename T>\",\r\n        \"auto primitive_deserialize(Archive const& in, Size& index, T& value)\",\r\n        \"    -> std::enable_if_t<std::is_integral_v<T>>\",\r\n        \"{\",\r\n        \"    if (in.size() - index < sizeof(T))\",\r\n        \"    {\",\r\n        \"        throw std::range_error{ \\\"read out of range\\\" };\",\r\n        \"    }\",\r\n        \"    value = T{};\",\r\n        \"    for (auto i = 0; i < sizeof(T); ++i)\",\r\n        \"    {\",\r\n        \"        value |= (T{} | in[index]) << i * 8;\",\r\n        \"        ++index;\",\r\n        \"    }\",\r\n        \"}\",\r\n        \"\",\r\n        \"// Handle floating point types\",\r\n        \"template <typename T>\",\r\n        \"auto primitive_serialize(Archive& out, T value)\",\r\n        \"    -> std::enable_if_t<std::is_floating_point_v<T>, Size>\",\r\n        \"{\",\r\n        \"    auto ptr = static_cast<uint8_t*>(static_cast<void*>(&value));\",\r\n        \"    // Copy all the bytes\",\r\n        \"    for (auto i = 0; i < sizeof(T); ++i, ++ptr)\",\r\n        \"    {\",\r\n        \"        out.push_back(*ptr);\",\r\n        \"    }\",\r\n        \"    return sizeof(T);\",\r\n        \"}\",\r\n        \"template <typename T>\",\r\n        \"auto primitive_deserialize(Archive const& in, Size& index, T& value)\",\r\n        \"    -> std::enable_if_t<std::is_floating_point_v<T>>\",\r\n        \"{\",\r\n        \"    if (in.size() - index < sizeof(T))\",\r\n        \"    {\",\r\n        \"        throw std::range_error{ \\\"read out of range\\\" };\",\r\n        \"    }\",\r\n        \"    auto ptr = static_cast<uint8_t*>(static_cast<void*>(&value));\",\r\n        \"    for (auto i = 0; i < sizeof(T); ++i, ++ptr)\",\r\n        \"    {\",\r\n        \"        *ptr = in[index];\",\r\n        \"        ++index;\",\r\n        \"    }\",\r\n        \"}\",\r\n        \"\",\r\n        \"template <typename T>\",\r\n        \"struct PrimitiveSerialization\",\r\n        \"{\",\r\n        \"    static Size serialize(Archive& out, T const& value)\",\r\n        \"    {\",\r\n        \"        return primitive_serialize(out, value);\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    static void deserialize(Archive const& in, Size& index, T& value)\",\r\n        \"    {\",\r\n        \"        primitive_deserialize(in, index, value);\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"struct Vertex { float x, y, z; float u, v; uint32_t color; };\",\r\n        \"struct Mesh\",\r\n        \"{\",\r\n        \"    std::vector<Vertex> vertices;\",\r\n        \"    std::vector<uint32_t> indices;\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <template <typename> typename Serializer = PrimitiveSerialization>\",\r\n        \"struct MeshSerializer\",\r\n        \"{\",\r\n        \"private:\",\r\n        \"    template <typename T>\",\r\n        \"    static void write(Archive& out, T const& value)\",\r\n        \"    {\",\r\n        \"        Serializer<T>::serialize(out, value);\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    template <typename T>\",\r\n        \"    static void read(Archive const& in, Size& index, T& value)\",\r\n        \"    {\",\r\n        \"        Serializer<T>::deserialize(in, index, value);\",\r\n        \"    }\",\r\n        \"\",\r\n        \"public:\",\r\n        \"    static Archive serialize(Mesh const& mesh)\",\r\n        \"    {\",\r\n        \"        Archive out;\",\r\n        \"        write(out, static_cast<uint32_t>(mesh.vertices.size()));\",\r\n        \"        write(out, static_cast<uint32_t>(mesh.indices.size()));\",\r\n        \"\",\r\n        \"        for (auto const& vertex : mesh.vertices)\",\r\n        \"        {\",\r\n        \"            write(out, vertex.x);\",\r\n        \"            write(out, vertex.y);\",\r\n        \"            write(out, vertex.z);\",\r\n        \"            write(out, vertex.u);\",\r\n        \"            write(out, vertex.v);\",\r\n        \"            write(out, vertex.color);\",\r\n        \"        }\",\r\n        \"        for (auto const& index : mesh.indices)\",\r\n        \"        {\",\r\n        \"            write(out, index);\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        return out;\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    static Mesh deserialize(Archive const& in)\",\r\n        \"    {\",\r\n        \"        Mesh mesh;\",\r\n        \"        Size index = 0;\",\r\n        \"        uint32_t vertex_count, index_count;\",\r\n        \"        read(in, index, vertex_count);\",\r\n        \"        read(in, index, index_count);\",\r\n        \"\",\r\n        \"        mesh.vertices.resize(vertex_count);\",\r\n        \"        mesh.indices.resize(index_count);\",\r\n        \"\",\r\n        \"        for (uint32_t i = 0; i < vertex_count; ++i)\",\r\n        \"        {\",\r\n        \"            auto& vertex = mesh.vertices[i];\",\r\n        \"            read(in, index, vertex.x);\",\r\n        \"            read(in, index, vertex.y);\",\r\n        \"            read(in, index, vertex.z);\",\r\n        \"            read(in, index, vertex.u);\",\r\n        \"            read(in, index, vertex.v);\",\r\n        \"            read(in, index, vertex.color);\",\r\n        \"        }\",\r\n        \"        for (uint32_t i = 0; i < index_count; ++i)\",\r\n        \"        {\",\r\n        \"            read(in, index, mesh.indices[i]);\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        if (index != in.size())\",\r\n        \"        {\",\r\n        \"            throw std::invalid_argument{ \\\"incompatible archive\\\" };\",\r\n        \"        }\",\r\n        \"\",\r\n        \"        return mesh;\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"static void example()\",\r\n        \"{\",\r\n        \"    Mesh const mesh = /* mesh data */;\",\r\n        \"    {\",\r\n        \"        {\",\r\n        \"            { 0.f, 0.f, 0.f, 0.f, 0.f, 0xff000000 },\",\r\n        \"            { 1.f, 0.f, 0.f, 1.f, 0.f, 0xffff0000 },\",\r\n        \"            { 1.f, 1.f, 0.f, 1.f, 1.f, 0xffffff00 },\",\r\n        \"            { 0.f, 1.f, 0.f, 0.f, 1.f, 0xff00ff00 }\",\r\n        \"        },\",\r\n        \"        {\",\r\n        \"            0, 1, 2,\",\r\n        \"            1, 2, 3\",\r\n        \"        }\",\r\n        \"    };\",\r\n        \"\",\r\n        \"    auto const buffer = MeshSerializer<>::serialize(mesh);\",\r\n        \"\",\r\n        \"    auto const mesh_copy = MeshSerializer<>::deserialize(buffer);\",\r\n        \"}\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12, \"#b98eb2\", 13, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 8, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 5, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#91968b\", 29 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 19, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 7, \"#d3a869\", 2, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 16, \"#d3a869\", 1, \"#cccccc\", 3, \"#d38569\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 6, \"#b98eb2\", 6, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 12, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 15, \"#819dc2\", 1, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 21, \"#cccccc\", 1, \"#d38569\", 8, \"#b98eb2\", 5, \"#cccccc\", 6, \"#d38569\", 4, \"#cccccc\", 9, \"#d3a869\", 1, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 16, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 4, \"#c8c8c8\", 4, \"#cccccc\", 13, \"#b98eb2\", 6, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 14, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#7da76f\", 20, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 12, \"#d3a869\", 1, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 6, \"#b98eb2\", 6, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 18, \"#d3a869\", 1, \"#cccccc\", 23, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 16 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#91968b\", 30 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 19, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 7, \"#d3a869\", 2, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 22, \"#d3a869\", 1, \"#cccccc\", 3, \"#d38569\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 6, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 3, \"#b98eb2\", 11, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 12 ],\r\n        [ \"#91968b\", 25 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 6, \"#b98eb2\", 6, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 12, \"#c8c8c8\", 9, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 5, \"#d38569\", 21, \"#cccccc\", 1, \"#d38569\", 8, \"#b98eb2\", 5, \"#cccccc\", 6, \"#d38569\", 4, \"#cccccc\", 9, \"#d3a869\", 1, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 22, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 4, \"#c8c8c8\", 4, \"#cccccc\", 13, \"#b98eb2\", 6, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 14, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 2, \"#7da76f\", 20, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 6, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 3, \"#b98eb2\", 11, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 12 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 6, \"#b98eb2\", 6, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 25 ],\r\n        [ \"#cccccc\", 16 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 22 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d38569\", 5, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 7, \"#d3a869\", 2, \"#b98eb2\", 5, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"lightgreen\", 19, \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d38569\", 8, \"#b98eb2\", 5, \"#cccccc\", 6, \"#d38569\", 4, \"#cccccc\", 9, \"#d3a869\", 1, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"lightgreen\", 29, \"#cccccc\", 19 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 7, \"#cccccc\", 2, \"#b98eb2\", 6, \"plum\", 1, \"#cccccc\", 2, \"plum\", 1, \"#cccccc\", 2, \"plum\", 1, \"#cccccc\", 2, \"#b98eb2\", 6, \"plum\", 1, \"#cccccc\", 2, \"plum\", 1, \"#cccccc\", 2, \"#d38569\", 9, \"plum\", 5, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 4 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"plum\", 8, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"plum\", 7, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 11, \"#cccccc\", 2, \"#d38569\", 22, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 14 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 5, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 7, \"#d3a869\", 2, \"#b98eb2\", 5, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d3a869\", 18, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 3, \"lightgreen\", 9, \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 4, \"#cccccc\", 1, \"#d38569\", 8, \"#b98eb2\", 5, \"#cccccc\", 6, \"#d38569\", 4, \"#cccccc\", 9, \"#d3a869\", 1, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d3a869\", 18, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 3, \"lightgreen\", 11, \"#cccccc\", 19 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d38569\", 8, \"#c8c8c8\", 9, \"#cccccc\", 1, \"#d38569\", 5, \"#b98eb2\", 5, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 4 ],\r\n        [ \"#c8c8c8\", 13, \"#cccccc\", 6, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 7, \"plum\", 8, \"#cccccc\", 1, \"#c8c8c8\", 4, \"#cccccc\", 5 ],\r\n        [ \"#c8c8c8\", 13, \"#cccccc\", 6, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 7, \"plum\", 7, \"#cccccc\", 1, \"#c8c8c8\", 4, \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#b98eb2\", 10, \"#cccccc\", 16, \"plum\", 8, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13, \"plum\", 5, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#b98eb2\", 10, \"#cccccc\", 15, \"plum\", 7, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#c8c8c8\", 17, \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 11, \"#d38569\", 5, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d38569\", 8, \"#b98eb2\", 5, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 13, \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 13, \"#cccccc\", 8, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 17, \"#cccccc\", 26 ],\r\n        [ \"#c8c8c8\", 12, \"#cccccc\", 26 ],\r\n        [ \"#c8c8c8\", 12, \"#cccccc\", 25 ],\r\n        [  ],\r\n        [ \"#cccccc\", 13, \"plum\", 8, \"#cccccc\", 1, \"#c8c8c8\", 6, \"#cccccc\", 15 ],\r\n        [ \"#cccccc\", 13, \"plum\", 7, \"#cccccc\", 1, \"#c8c8c8\", 6, \"#cccccc\", 14 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#d38569\", 9, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 24 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 16, \"#cccccc\", 16, \"plum\", 8, \"#cccccc\", 4 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 19, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 19, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 19, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 19, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 19, \"plum\", 1, \"#cccccc\", 2 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 19, \"plum\", 5, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#d38569\", 9, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 23 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#c8c8c8\", 16, \"#cccccc\", 17, \"plum\", 7, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 13, \"#c8c8c8\", 4, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 18, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 2, \"#7da76f\", 23, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#d38569\", 7, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 9, \"#b98eb2\", 6, \"#cccccc\", 7, \"#91968b\", 15, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 14, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 11, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 14, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 11, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 14, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 11, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 14, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 11, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 10 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#819dc2\", 13, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#819dc2\", 13, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 2, \"#819dc2\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 6 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 9, \"#d38569\", 14, \"#cccccc\", 4, \"#c8c8c8\", 9, \"#cccccc\", 7 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 12, \"#d38569\", 14, \"#cccccc\", 4, \"#c8c8c8\", 11, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 1 ]\r\n    ]\r\n}",
	"content/code/36_type_list.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], \"hc\", [12,10,34], [13,23,64], [20,23,61], [79,25,44]],\r\n            [\"sl\", [22,25]],\r\n            [\"sm\", [24,4,19], [24,71,72]],\r\n            [\"sm\", [24,19,45]],\r\n            [\"sm\", [24,47,71]],\r\n            [\"sm\", [23,4,46]],\r\n            [\"cm\", \"sn\", [25,0,\"How to write something like this?\",\"question\"]],\r\n            [\"cn\", \"sl\", [12,13]],\r\n            [\"sc\", [12,10,34]],\r\n            [\"sn\", [13,0,\"What information do we need to extract?\",\"question\"]],\r\n            [\"an\", [13,0,\"Their parameter packs.\"]],\r\n            [\"sn\", [13,0,\"How to extract a parameter pack?\",\"question\"]],\r\n            [\"an\", [13,0,\"Type deduction. Partial specialization/function calls.\"]],\r\n            [\"cn\", \"sc\", [13,23,64]],\r\n            [\"sl\", [4,5]],\r\n            [\"sl\", [6,8], [10,11]],\r\n            [\"sm\", [6,10,24], [6,26,40]],\r\n            [\"sm\", [7,26,41], [7,43,58]],\r\n            [\"cm\", \"sl\", 9],\r\n            [\"sm\", [9,26,31]],\r\n            [\"sm\", [9,33,38]],\r\n            [\"cm\"],\r\n            [\"hl\", [3,5],[11,13], \"sl\", [15,16]],\r\n            [\"sm\", [6,10,24], [15,10,24]],\r\n            [\"sm\", [6,26,40], [15,26,40]],\r\n            [\"sm\", [7,26,41], [16,32,47]],\r\n            [\"sm\", [7,43,58], [16,49,64]],\r\n            [\"cm\", \"sl\", 17],\r\n            [\"sm\", [9,17,39], [17,7,29]],\r\n            [\"sm\", [17,32,42]],\r\n            [\"cm\", \"hl\", [6,10]],\r\n            [\"sl\", [18,21]],\r\n            [\"sc\", [20,23,61]],\r\n            [\"sm\", [20,49,53], [20,55,59]],\r\n            [\"sm\", [20,32,60]],\r\n            [\"sm\", [17,7,29], [20,23,61]],\r\n            [\"cm\"],\r\n            [\"hl\", [1,2], [15,25], \"sl\", [46,57]],\r\n            [\"sm\", [48,4,15], [48,34,35], [52,4,15], [52,34,35], [56,4,15], [56,34,35]],\r\n            [\"sm\", [48,15,16], [52,15,16], [56,15,16]],\r\n            [\"sm\", [48,18,34], [52,18,34], [56,18,34]],\r\n            [\"sm\", [47,4,8], [48,18,22], [51,4,7], [52,24,27], [55,4,9], [56,29,34]],\r\n            [\"cm\", \"sn\", [57,0,\"How to do this?\",\"question\"]],\r\n            [\"cn\", \"sl\", [43,45]],\r\n            [\"sl\", [28,30], 36],\r\n            [\"sl\", 31],\r\n            [\"sl\", [32,35]],\r\n            [\"sm\", [32,26,41], [35,4,5]],\r\n            [\"sm\", [33,8,17]],\r\n            [\"sm\", [34,8,15]],\r\n            [\"cm\", \"sl\", [37,39], [41,42]],\r\n            [\"sm\", [28,24,56], [37,10,42]],\r\n            [\"sm\", [38,22,23]],\r\n            [\"cm\", \"sl\", 40],\r\n            [\"hl\", [28,57], \"sl\", [67,68]],\r\n            [\"sm\", [67,28,31]],\r\n            [\"sm\", [67,35,59]],\r\n            [\"sm\", [67,28,31,\"positive\"], [67,50,53]],\r\n            [\"sm\", [68,28,33]],\r\n            [\"sm\", [68,35,59]],\r\n            [\"sm\", [68,28,33,\"negative\"]],\r\n            [\"cm\", \"sn\", [68,0,\"What is different?\",\"question\"]],\r\n            [\"sn\", [68,0,\"ContainsType := bool, not a type\"]],\r\n            [\"cn\", \"sl\", [60,61]],\r\n            [\"sl\", [62,63]],\r\n            [\"sm\", [63,28,29], [63,31,32]],\r\n            [\"cm\", \"sl\", [64,66]],\r\n            [\"sm\", [65,28,29], [65,31,32]],\r\n            [\"sm\", [65,45,69]],\r\n            [\"cm\", \"sn\", [67,15,\"ContainsType<int,   float, double, int, void> ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"negative\"], [65,15,27,\"positive\"]],\r\n            [\"cm\", \"an\", [67,15,\"ContainsType<int,   double, int, void>        ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"negative\"], [65,15,27,\"positive\"]],\r\n            [\"cm\", \"an\", [67,15,\"ContainsType<int,   int, void>                ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"positive\"], [65,15,27,\"negative\"]],\r\n            [\"cm\", \"an\", [67,15,\"true\"]],\r\n            [\"cm\", \"sn\", [68,15,\"ContainsType<short, float, double, int, void> ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"negative\"], [65,15,27,\"positive\"]],\r\n            [\"cm\", \"an\", [68,15,\"ContainsType<short, double, int, void>        ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"negative\"], [65,15,27,\"positive\"]],\r\n            [\"cm\", \"an\", [68,15,\"ContainsType<short, int, void>                ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"negative\"], [65,15,27,\"positive\"]],\r\n            [\"cm\", \"an\", [68,15,\"ContainsType<short, void>                     ==\"]],\r\n            [\"sm\", [61,15,27,\"negative\"], [63,15,27,\"negative\"], [65,15,27,\"positive\"]],\r\n            [\"cm\", \"an\", [68,15,\"ContainsType<short>                           ==\"]],\r\n            [\"sm\", [61,15,27,\"positive\"], [63,15,27,\"negative\"], [65,15,27,\"negative\"]],\r\n            [\"cm\", \"an\", [68,15,\"false\"]],\r\n            [\"cn\"],\r\n            [\"hl\", [60,68], \"sl\", [84,91]],\r\n            [\"sm\", [86,4,21], [86,45,46], [90,4,21], [90,42,43]],\r\n            [\"sm\", [86,21,27], [90,21,24]],\r\n            [\"sm\", [86,29,45], [90,26,42]],\r\n            [\"sm\", [85,13,37]],\r\n            [\"sm\", [89,13,29]],\r\n            [\"cm\", \"sn\", [91,0,\"How to do this? Is this hard?\",\"question\"]],\r\n            [\"cn\", \"sl\", [78,79]],\r\n            [\"sc\", [79,25,44], \"sl\", [80,83]],\r\n            [\"sm\", [79,25,43]],\r\n            [\"sm\", [80,4,29]],\r\n            [\"sm\", [81,9,27]],\r\n            [\"sm\", [82,9,30]],\r\n            [\"cm\"],\r\n            [\"hl\", [78,92], \"sl\", [104,107]],\r\n            [\"sm\", [106,4,19], [106,75,76]],\r\n            [\"sm\", [106,19,22,\"positive\"], [105,13,16]],\r\n            [\"am\", [106,24,28,\"positive\"], [105,18,22]],\r\n            [\"am\", [106,30,34,\"negative\"]],\r\n            [\"am\", [106,36,42,\"positive\"], [105,24,30]],\r\n            [\"am\", [106,44,47,\"negative\"]],\r\n            [\"am\", [106,49,54,\"positive\"], [105,32,37]],\r\n            [\"am\", [106,56,61,\"negative\"]],\r\n            [\"am\", [106,63,69,\"negative\"]],\r\n            [\"am\", [106,71,75,\"negative\"]],\r\n            [\"cm\", \"sn\", [107,0,\"How to implement it?\",\"question\"]],\r\n            [\"cn\", \"sl\", [93,95]],\r\n            [\"sm\", [93,10,29]],\r\n            [\"sm\", [94,32,52]],\r\n            [\"sm\", [94,54,64]],\r\n            [\"sm\", [95,7,27]],\r\n            [\"cm\", \"sl\", [96,97]],\r\n            [\"sm\", [96,10,29]],\r\n            [\"sm\", [96,31,65]],\r\n            [\"sm\", [97,54,80]],\r\n            [\"cm\", \"sl\", 98],\r\n            [\"sm\", [98,16,33], [98,93,94]],\r\n            [\"sm\", [98,33,70]],\r\n            [\"sm\", [98,72,93]],\r\n            [\"sm\", [98,7,16], [98,94,95]],\r\n            [\"cm\", \"sl\", 99],\r\n            [\"sl\", [100,103]],\r\n            [\"sm\", [101,10,27]],\r\n            [\"sm\", [102,32,49], [102,83,84]],\r\n            [\"sm\", [102,49,61]],\r\n            [\"sm\", [102,63,83]],\r\n            [\"sm\", [102,23,32], [102,84,85]],\r\n            [\"cm\"],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"template <typename... Types>\",\r\n        \"struct TypeList {};\",\r\n        \"\",\r\n        \"template <typename, typename>\",\r\n        \"struct ConcatTypeListImpl;\",\r\n        \"template <typename... TA, typename... TB>\",\r\n        \"struct ConcatTypeListImpl<TypeList<TA...>, TypeList<TB...>>\",\r\n        \"{\",\r\n        \"    using Type = TypeList<TA..., TB...>;\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename TA, typename TB>\",\r\n        \"using ConcatTypeList = typename ConcatTypeListImpl<TA, TB>::Type;\",\r\n        \"\",\r\n        \"template <typename... TA, typename... TB>\",\r\n        \"constexpr auto concat_type_list(TypeList<TA...>, TypeList<TB...>)\",\r\n        \"    -> TypeList<TA..., TB...> { return {}; }\",\r\n        \"\",\r\n        \"template <typename TA, typename TB>\",\r\n        \"using ConcatTypeList = decltype(concat_type_list(TA{}, TB{}));\",\r\n        \"\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    TypeList<bool, float, int, char, unsigned>,\",\r\n        \"    ConcatTypeList<TypeList<bool, float, int>, TypeList<char, unsigned>>\",\r\n        \">);\",\r\n        \"\",\r\n        \"\",\r\n        \"template <size_t Index, typename First, typename... Rest>\",\r\n        \"struct IndexTypesImpl\",\r\n        \"{\",\r\n        \"    static_assert(Index <= sizeof...(Rest), \\\"index out of range\\\");\",\r\n        \"    using Type = typename IndexTypesImpl<\",\r\n        \"        Index - 1,\",\r\n        \"        Rest...\",\r\n        \"    >::Type;\",\r\n        \"};\",\r\n        \"template <typename First, typename... Rest>\",\r\n        \"struct IndexTypesImpl<0, First, Rest...>\",\r\n        \"{\",\r\n        \"    using Type = First;\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <size_t Index, typename... Types>\",\r\n        \"using IndexTypes = typename IndexTypesImpl<Index, Types...>::Type;\",\r\n        \"\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    bool,\",\r\n        \"    IndexTypes<0, bool, int, float>\",\r\n        \">);\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    int,\",\r\n        \"    IndexTypes<1, bool, int, float>\",\r\n        \">);\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    float,\",\r\n        \"    IndexTypes<2, bool, int, float>\",\r\n        \">);\",\r\n        \"\",\r\n        \"\",\r\n        \"template <typename T, typename... Types>\",\r\n        \"constexpr bool ContainsType = false;\",\r\n        \"template <typename T, typename... Rest>\",\r\n        \"constexpr bool ContainsType<T, T, Rest...> = true;\",\r\n        \"template <typename T, typename J, typename... Rest>\",\r\n        \"constexpr bool ContainsType<T, J, Rest...> = ContainsType<T, Rest...>;\",\r\n        \"\",\r\n        \"static_assert( ContainsType<int,   float, double, int, void>);\",\r\n        \"static_assert(!ContainsType<short, float, double, int, void>);\",\r\n        \"\",\r\n        \"template <typename T, typename TypeList>\",\r\n        \"constexpr bool ListContainsType = false;\",\r\n        \"template <typename T, typename... Types>\",\r\n        \"constexpr bool ListContainsType<T, TypeList<Types...>> = ContainsType<T, Types...>;\",\r\n        \"\",\r\n        \"static_assert( ListContainsType<int,   TypeList<float, double, int, void>>);\",\r\n        \"static_assert(!ListContainsType<short, TypeList<float, double, int, void>>);\",\r\n        \"\",\r\n        \"template <typename T, typename... Types>\",\r\n        \"using AppendTypeUnique = std::conditional_t<\",\r\n        \"    ContainsType<T, Types...>,\",\r\n        \"    /*?*/TypeList<Types...>,\",\r\n        \"    /*:*/TypeList<Types..., T>>;\",\r\n        \"\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    TypeList<bool, int, float, double>,\",\r\n        \"    AppendTypeUnique<double, bool, int, float>\",\r\n        \">);\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    TypeList<bool, int, float>,\",\r\n        \"    AppendTypeUnique<int, bool, int, float>\",\r\n        \">);\",\r\n        \"\",\r\n        \"template <typename... Results>\",\r\n        \"constexpr auto unique_type_list(TypeList<Results...>, TypeList<>)\",\r\n        \"    -> TypeList<Results...> { return {}; }\",\r\n        \"template <typename... Results, typename First, typename... Inputs>\",\r\n        \"constexpr auto unique_type_list(TypeList<Results...>, TypeList<First, Inputs...>)\",\r\n        \"    -> decltype(unique_type_list(AppendTypeUnique<First, Results...>{}, TypeList<Inputs...>{}))\",\r\n        \"{ return {}; }\",\r\n        \"\",\r\n        \"template <typename... Types>\",\r\n        \"using UniqueTypeList = decltype(unique_type_list(TypeList<>{}, TypeList<Types...>{}));\",\r\n        \"\",\r\n        \"static_assert(std::is_same_v<\",\r\n        \"    TypeList<int, bool, double, float>,\",\r\n        \"    UniqueTypeList<int, bool, bool, double, int, float, float, double, bool>\",\r\n        \">);\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 9, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 2, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 2, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 18, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 6, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 5, \"#d3a869\", 2, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 2, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 2, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 15, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d38569\", 18, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 2, \"#d3a869\", 2, \"#cccccc\", 3, \"lightgreen\", 4, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 2, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 2, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 6, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 7, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 5, \"#d3a869\", 2, \"#cccccc\", 7, \"#b98eb2\", 7, \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 2, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 2, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 15, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"lightgreen\", 16, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 4, \"#d3a869\", 2, \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 18, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 3, \"#d38569\", 8, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 3 ],\r\n        [  ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#d38569\", 7, \"#d3a869\", 5, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 5, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 14 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 17, \"#cccccc\", 1, \"#d3a869\", 6, \"#cccccc\", 3, \"#b98eb2\", 6, \"#cccccc\", 4, \"#d38569\", 4, \"#cccccc\", 3, \"#7da76f\", 20, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d38569\", 14, \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 14, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 12, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 7, \"lightgreen\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 5, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 14, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#d3a869\", 5, \"#cccccc\", 2, \"#d3a869\", 4, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#d38569\", 7, \"#d3a869\", 5, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 11, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d38569\", 14, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 2, \"#d3a869\", 5, \"#cccccc\", 6, \"lightgreen\", 4, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#b98eb2\", 8, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 14, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 14, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 14, \"#cccccc\", 1, \"#819dc2\", 1, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 3 ],\r\n        [  ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 15, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 13, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 4, \"#cccccc\", 7, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 4, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 13, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 4, \"#cccccc\", 20, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 4, \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 15, \"#b98eb2\", 3, \"#cccccc\", 4, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 15, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 19, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 17, \"#d3a869\", 1, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 21, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 5, \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 19, \"#b98eb2\", 3, \"#cccccc\", 4, \"#d38569\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 19, \"#b98eb2\", 5, \"#cccccc\", 2, \"#d38569\", 8, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 4 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 17, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 13, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 17, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 5, \"#cccccc\", 5 ],\r\n        [ \"#91968b\", 9, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 5 ],\r\n        [ \"#91968b\", 9, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 5, \"#d3a869\", 1, \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 20, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 20, \"#cccccc\", 1, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 3 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 6, \"#d38569\", 8, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 7, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 7, \"#b98eb2\", 7, \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 7, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 5, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 6, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 2, \"#d3a869\", 6, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 7, \"#b98eb2\", 8, \"#cccccc\", 1, \"lightgreen\", 16, \"#cccccc\", 1, \"#d38569\", 16, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 2, \"#d3a869\", 7, \"#cccccc\", 8, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 6, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 2, \"#b98eb2\", 7, \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 5, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#d38569\", 15, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"lightgreen\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 6, \"#d38569\", 8, \"#cccccc\", 1, \"#d3a869\", 5, \"#cccccc\", 9 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 12 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#d38569\", 18, \"#cccccc\", 1, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 3, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 5, \"#cccccc\", 2, \"#b98eb2\", 6, \"#cccccc\", 2, \"#b98eb2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 3 ]\r\n    ]\r\n}",
	"content/code/50_particle_type.json": "{\r\n    \"sets\": {\r\n        \"representation\": [\r\n            [\"sl\", [28,29], 47],\r\n            [\"sl\", [34,36], 46],\r\n            [\"sl\", [1,2], [26,27]],\r\n            [\"sl\", [3,4]],\r\n            [\"sl\", [5,7]],\r\n            [\"sl\", [7,10], 15],\r\n            [\"sl\", 11],\r\n            [\"sl\", [12,14]],\r\n            [\"hl\", [10,16], \"sl\", 17],\r\n            [\"sl\", 18],\r\n            [\"sl\", 19],\r\n            [\"sl\", 20],\r\n            [\"sl\", 21],\r\n            [\"sl\", [22,25]],\r\n            [\"hl\", [7,25]],\r\n            [\"sl\", [30,33]],\r\n            [\"sl\", [37,39]],\r\n            [\"sl\", [40,45]],\r\n            [\"hl\", [3,6], [30,33], [36,46], \"sl\", 9, 17, 19, 21],\r\n            null\r\n        ],\r\n        \"system\": [\r\n            [\"sl\", 49],\r\n            [\"sm\", [49,0,9], \"sn\", [49,0,\"constexpr with a custom type?\",\"question\"]],\r\n            [\"sm\", [49,0,9,\"positive\"], \"sn\", [49,0,\"Yes! You can use constexpr with any 'literal' type\"]],\r\n            [\"cn\", \"sm\", [49,53,63]],\r\n            [\"sm\", [49,66,76]],\r\n            [\"sm\", [49,78,89]],\r\n            [\"cm\", \"sl\", [50,51]],\r\n            [\"sl\", [52,55]],\r\n            [\"sm\", [52,32,53], [55,0,1]],\r\n            [\"sm\", [52,53,64]],\r\n            [\"sm\", [53,62,79], [53,98,99], [54,4,21], [54,39,40]],\r\n            [\"sm\", [53,79,93], [54,21,33]],\r\n            [\"sm\", [53,95,98], [54,35,39]],\r\n            [\"sm\", [53,33,45], [53,99,100]],\r\n            [\"cm\"],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"struct ExampleParticle\",\r\n        \"{\",\r\n        \"    float px, py;\",\r\n        \"    float vx, vy;\",\r\n        \"\",\r\n        \"    float life_rate_     = 0.f; // 1 / total_lifetime\",\r\n        \"    float life_progress_ = 0.f;\",\r\n        \"\",\r\n        \"    void update(float delta_seconds) noexcept\",\r\n        \"    {\",\r\n        \"        life_progress_ += life_rate_ * delta_seconds;\",\r\n        \"\",\r\n        \"        px += vx * delta_seconds;\",\r\n        \"        py += vy * delta_seconds;\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    auto is_alive() const noexcept -> bool\",\r\n        \"    { return life_progress_ < 1.f; }\",\r\n        \"    auto position() const noexcept -> std::array<float, 2>\",\r\n        \"    { return { px, py }; }\",\r\n        \"    void position(float x, float y) noexcept\",\r\n        \"    {\",\r\n        \"        px = x;\",\r\n        \"        py = y;\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"struct ExampleParticleType\",\r\n        \"{\",\r\n        \"    float life_min, life_max;\",\r\n        \"    float pos_min, pos_max;\",\r\n        \"    float vel_min, vel_max;\",\r\n        \"\",\r\n        \"    using Particle = ExampleParticle;\",\r\n        \"    Particle create(RandomEngine& engine, float x, float y) const\",\r\n        \"    {\",\r\n        \"        std::uniform_real_distribution<float> rnd_life{ life_min, life_max };\",\r\n        \"        std::uniform_real_distribution<float> rnd_pos {  pos_min,  pos_max };\",\r\n        \"        std::uniform_real_distribution<float> rnd_vel {  vel_min,  vel_max };\",\r\n        \"        return                                                                            \",\r\n        \"        {\",\r\n        \"            rnd_pos(engine) + x, rnd_pos(engine) + y,\",\r\n        \"            rnd_vel(engine)    , rnd_vel(engine)    ,\",\r\n        \"            1 / rnd_life(engine)\",\r\n        \"        };\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"constexpr auto example_slow   = ExampleParticleType{ 0.6f, 1.5f,  -2.f,  2.f, -30.f, 30.f };\",\r\n        \"constexpr auto example_medium = ExampleParticleType{ 0.5f, 1.2f,  -4.f,  4.f, -50.f, 50.f };\",\r\n        \"constexpr auto example_fast   = ExampleParticleType{ 0.4f, 0.8f, -20.f, 20.f, -70.f, 70.f };\",\r\n        \"constexpr auto example_system = CreateParticleSystem(\\\"example\\\"sv,\",\r\n        \"    EmitOnDeath(example_slow, 1, EmitOnDeath(example_slow, 3, EmitContinuously(example_medium, 5.f))),\",\r\n        \"    EmitContinuously(example_fast, 10.f)\",\r\n        \");\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 7, \"#d38569\", 15 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 2, \"#cccccc\", 2, \"plum\", 2, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 2, \"#cccccc\", 2, \"plum\", 2, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"plum\", 15, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#91968b\", 21 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 15, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 15, \"#b98eb2\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"plum\", 23, \"#cccccc\", 3, \"plum\", 11, \"#cccccc\", 16 ],\r\n        [  ],\r\n        [ \"plum\", 11, \"#cccccc\", 3, \"plum\", 3, \"#cccccc\", 16 ],\r\n        [ \"plum\", 11, \"#cccccc\", 3, \"plum\", 3, \"#cccccc\", 16 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 8, \"#cccccc\", 3, \"#b98eb2\", 15, \"#cccccc\", 3, \"#b98eb2\", 4 ],\r\n        [ \"#cccccc\", 6, \"#b98eb2\", 7, \"plum\", 15, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 8, \"#cccccc\", 3, \"#b98eb2\", 15, \"#cccccc\", 3, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 6, \"#b98eb2\", 7, \"#cccccc\", 2, \"plum\", 2, \"#cccccc\", 2, \"plum\", 3, \"#cccccc\", 4 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 8, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 3, \"#b98eb2\", 6, \"#cccccc\", 3, \"#b98eb2\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"plum\", 11, \"#cccccc\", 4 ],\r\n        [ \"plum\", 11, \"#cccccc\", 4 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 19 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 8, \"#cccccc\", 2, \"plum\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 7, \"#cccccc\", 2, \"plum\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 7, \"#cccccc\", 2, \"plum\", 7, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 9, \"#cccccc\", 2, \"#d38569\", 15, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 13, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d38569\", 12, \"#cccccc\", 10, \"#b98eb2\", 6, \"#cccccc\", 3, \"#b98eb2\", 6, \"#cccccc\", 3, \"#b98eb2\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 25, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 12, \"plum\", 8, \"#cccccc\", 2, \"plum\", 9, \"#cccccc\", 2 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 25, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 13, \"plum\", 7, \"#cccccc\", 3, \"plum\", 8, \"#cccccc\", 2 ],\r\n        [ \"#d36971\", 11, \"#cccccc\", 2, \"#d38569\", 25, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 13, \"plum\", 7, \"#cccccc\", 3, \"plum\", 8, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 90 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 53 ],\r\n        [ \"#cccccc\", 53 ],\r\n        [ \"#819dc2\", 14, \"#cccccc\", 18 ],\r\n        [ \"#cccccc\", 10 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 17, \"#d38569\", 19, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 4, \"#819dc2\", 3, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 3, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 17, \"#d38569\", 19, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 4, \"#819dc2\", 3, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 3, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 17, \"#d38569\", 19, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 17, \"#d38569\", 20, \"#cccccc\", 1, \"#7da76f\", 11, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 15, \"#cccccc\", 15, \"#819dc2\", 1, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 15, \"#819dc2\", 1, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 17, \"#819dc2\", 3, \"#cccccc\", 4 ],\r\n        [ \"#d38569\", 20, \"#cccccc\", 15, \"#819dc2\", 4, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ]\r\n    ]\r\n}",
	"content/code/51_particle_system_interface.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,2], 8],\r\n            [\"sl\", [3,5]],\r\n            [\"sl\", [6,7]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"class ParticleSystem\",\r\n        \"{\",\r\n        \"public:\",\r\n        \"    virtual void update(fw::Game::TimeSpan delta_time, RandomEngine& random) = 0;\",\r\n        \"    virtual void render(fw::Surface& screen) const noexcept = 0;\",\r\n        \"\",\r\n        \"    virtual ~ParticleSystem() noexcept = default;\",\r\n        \"};\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 6, \"#d38569\", 14 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 17, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 2, \"#d38569\", 9, \"#cccccc\", 12, \"#d38569\", 12, \"#cccccc\", 12, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 17, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 10, \"#b98eb2\", 15, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 12, \"#c8c8c8\", 15, \"#cccccc\", 3, \"#b98eb2\", 9, \"#cccccc\", 2, \"#b98eb2\", 7, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ]\r\n    ]\r\n}",
	"content/code/52_particle_system.json": "{\r\n    \"sets\": {\r\n        \"api\": [\r\n            [\"sl\", [221, 226], 228, 244],\r\n            [\"sl\", 227],\r\n            [\"sm\", [227,11,51]],\r\n            [\"sm\", [227,59,82]],\r\n            [\"cm\", \"sl\", [229,243]],\r\n            [\"sm\", [232,7,40], [239,7,46]],\r\n            [\"cm\"],\r\n            null\r\n        ],\r\n        \"descriptions\": [\r\n            [\"sl\", [1,2], 219],\r\n            [\"hl\", [1,2], 219, \"sl\", [195,197], 217],\r\n            [\"sl\", [198,199]],\r\n            [\"sl\", [200,202]],\r\n            [\"sm\", [202,46,77]],\r\n            [\"cm\", \"sl\", [203,205]],\r\n            [\"sm\", [204,32,79]],\r\n            [\"sn\", [204,32,\"What does this do?\",\"question\"]],\r\n            [\"sn\", [204,32,\"std::index_sequence<0, 1, ..., N-2, N-1>{}\"]],\r\n            [\"cm\", \"cn\", \"sl\", [206,208]],\r\n            [\"sm\", [207,14,31], [208,42,73]],\r\n            [\"cm\", \"sl\", 209],\r\n            [\"sl\", [210,216]],\r\n            [\"sm\", [211,32,63]],\r\n            [\"sm\", [212,12,13], [213,12,13]],\r\n            [\"sm\", [214,12,53]],\r\n            [\"sm\", [214,55,82]],\r\n            [\"sm\", [214,82,90]],\r\n            [\"sm\", [195,22,30], [214,32,40], [214,49,52]],\r\n            [\"sm\", [207,24,31], [214,64,71], [214,90,93]],\r\n            [\"cm\"],\r\n            [\"hl\", [195,217], \"sl\", [86,98]],\r\n            [\"hl\", [86,98], \"sl\", [136,149]],\r\n            [\"sm\", [143,38,69], [147,45,59]],\r\n            [\"cm\"],\r\n            null\r\n        ],\r\n        \"particle_system\": [\r\n            [\"sl\", [151,153], 193],\r\n            [\"sl\", [154,159]],\r\n            [\"sl\", [160,165]],\r\n            [\"hl\", [160,165], \"sl\", [167,171]],\r\n            [\"sl\", [178,184]],\r\n            [\"sm\", [182,40,92]],\r\n            [\"cm\", \"hl\", [167,171], [178,184], \"sl\", [172,175]],\r\n            [\"sl\", [186,192]],\r\n            [\"sm\", [190,40,55]],\r\n            [\"cm\"],\r\n            null\r\n        ],\r\n        \"emitters\": [\r\n            [\"sl\", [4,10], \"hc\", [21,45,82]],\r\n            [\"hl\", [4,10], \"sl\", [12,14], 57],\r\n            [\"sl\", [15,16]],\r\n            [\"sl\", [20,22], 35],\r\n            [\"sl\", [23,25], 34],\r\n            [\"sl\", 26],\r\n            [\"sl\", [27,28], 33],\r\n            [\"sl\", [30,32]],\r\n            [\"sl\", 19],\r\n            [\"sl\", 18],\r\n            [\"sc\", [21,45,82]],\r\n            [\"sl\", 29],\r\n            [\"hl\", [18,35], \"sl\", [37,40]],\r\n            [\"hl\", [37,40], \"sl\", [42,43], 56],\r\n            [\"sl\", [44,55]],\r\n            [\"hl\", [12,57], \"sl\", [59,62], 84],\r\n            [\"sl\", [63,65]],\r\n            [\"sl\", [66,70]],\r\n            [\"hl\", [66,70], \"sl\", [72,75], 83],\r\n            [\"sl\", 76],\r\n            [\"sl\", 77],\r\n            [\"sl\", [78,79], 82],\r\n            [\"sl\", [80,81]],\r\n            [\"hl\", [59,84], \"sl\", [100,103], 134],\r\n            [\"sl\", [104,106]],\r\n            [\"sl\", [107,112]],\r\n            [\"hl\", [107,112], \"sl\", [114,117], 127],\r\n            [\"sl\", 118],\r\n            [\"sl\", [119,120], 126],\r\n            [\"sm\", [119,67,92]],\r\n            [\"cm\", \"sl\", [121,122], 125],\r\n            [\"sl\", [123,124]],\r\n            [\"hl\", [114,127], \"sl\", [129,133]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"namespace particles::detail\",\r\n        \"{\",\r\n        \"\",\r\n        \"struct SpawnInfo\",\r\n        \"{\",\r\n        \"    SpawnInfo() = default;\",\r\n        \"    RandomEngine& random;\",\r\n        \"    float x;\",\r\n        \"    float y;\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename ParticleType>\",\r\n        \"struct EmitterBase\",\r\n        \"{\",\r\n        \"    using Particle = typename ParticleType::Particle;\",\r\n        \"    std::vector<Particle> particles_;\",\r\n        \"\",\r\n        \"    static void default_on_death(Particle const&) noexcept {}\",\r\n        \"    template <typename OnDeath = decltype(default_on_death)>\",\r\n        \"    void update([[maybe_unused]] float const total_time, float const delta_time,\",\r\n        \"        [[maybe_unused]] SpawnInfo spawn_info, OnDeath on_death = default_on_death)\",\r\n        \"    {\",\r\n        \"        for (size_t i = particles_.size(); i != 0;)\",\r\n        \"        {\",\r\n        \"            --i;\",\r\n        \"            particles_[i].update(delta_time);\",\r\n        \"            if (!particles_[i].is_alive())\",\r\n        \"            {\",\r\n        \"                on_death(particles_[i]);\",\r\n        \"                using std::swap;\",\r\n        \"                swap(particles_[i], particles_[particles_.size() - 1]);\",\r\n        \"                particles_.pop_back();\",\r\n        \"            }\",\r\n        \"        }\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    void spawn_particle(ParticleType type, SpawnInfo spawn_info)\",\r\n        \"    {\",\r\n        \"        particles_.push_back(type.create(spawn_info.random, spawn_info.x, spawn_info.y));\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    void render(fw::Surface& screen) const noexcept\",\r\n        \"    {\",\r\n        \"        for (auto& particle : particles_)\",\r\n        \"        {\",\r\n        \"            // C++17 Structured binding\",\r\n        \"            auto const[fx, fy] = particle.position();\",\r\n        \"            auto const x = static_cast<fw::i32>(fx);\",\r\n        \"            auto const y = static_cast<fw::i32>(fy);\",\r\n        \"            if (x >= 0 && x < screen.width() &&\",\r\n        \"                y >= 0 && y < screen.height())\",\r\n        \"            {\",\r\n        \"                screen[x][y] = 0xffffffff;\",\r\n        \"            }\",\r\n        \"        }\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename T>\",\r\n        \"struct EmitterContinuous : EmitterBase<T>\",\r\n        \"{\",\r\n        \"    using Base = EmitterBase<T>;\",\r\n        \"    T type_;\",\r\n        \"    fw::f32 spawn_rate_;\",\r\n        \"    fw::i32 spawn_count_ = 0;\",\r\n        \"\",\r\n        \"    EmitterContinuous(T type, fw::f32 spawn_rate) :\",\r\n        \"        type_{ type },\",\r\n        \"        spawn_rate_{ spawn_rate }\",\r\n        \"    { }\",\r\n        \"\",\r\n        \"    template <typename OnDeath = decltype(Base::default_on_death)>\",\r\n        \"    void update(float const total_time, float const delta_time,\",\r\n        \"        SpawnInfo spawn_info, OnDeath on_death = Base::default_on_death)\",\r\n        \"    {\",\r\n        \"        Base::update(total_time, delta_time, spawn_info, on_death);\",\r\n        \"        auto const spawn_target = static_cast<fw::i32>(total_time * spawn_rate_);\",\r\n        \"        while (spawn_count_ < spawn_target)\",\r\n        \"        {\",\r\n        \"            ++spawn_count_;\",\r\n        \"            Base::spawn_particle(type_, spawn_info);\",\r\n        \"        }\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename T>\",\r\n        \"struct EmitterDescrContinuous\",\r\n        \"{\",\r\n        \"    using Emitter = EmitterContinuous<T>;\",\r\n        \"\",\r\n        \"    T particle_type;\",\r\n        \"    float spawn_rate; // in seconds between each spawn\",\r\n        \"\",\r\n        \"    Emitter spawn() const noexcept\",\r\n        \"    {\",\r\n        \"        return { particle_type, spawn_rate };\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename T, typename ParentEmitter>\",\r\n        \"struct EmitterOnDeath : EmitterBase<T>\",\r\n        \"{\",\r\n        \"    using Base = EmitterBase<T>;\",\r\n        \"    T type_;\",\r\n        \"    fw::i32 spawn_count_;\",\r\n        \"    ParentEmitter parent_emitter_;\",\r\n        \"\",\r\n        \"    EmitterOnDeath(T type, fw::i32 spawn_count, ParentEmitter parent_emitter) :\",\r\n        \"        type_{ type },\",\r\n        \"        spawn_count_{ spawn_count },\",\r\n        \"        parent_emitter_{ parent_emitter }\",\r\n        \"    { }\",\r\n        \"\",\r\n        \"    template <typename OnDeath = decltype(Base::default_on_death)>\",\r\n        \"    void update(float const total_time, float const delta_time,\",\r\n        \"        SpawnInfo spawn_info, OnDeath on_death = Base::default_on_death)\",\r\n        \"    {\",\r\n        \"        Base::update(total_time, delta_time, spawn_info, on_death);\",\r\n        \"        parent_emitter_.update(total_time, delta_time, spawn_info, [&](auto const& particle)\",\r\n        \"        {\",\r\n        \"            for (auto i = 0; i < spawn_count_; ++i)\",\r\n        \"            {\",\r\n        \"                auto[px, py] = particle.position();\",\r\n        \"                Base::spawn_particle(type_, { spawn_info.random, px, py });\",\r\n        \"            }\",\r\n        \"        });\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    void render(fw::Surface& screen) const noexcept\",\r\n        \"    {\",\r\n        \"        parent_emitter_.render(screen);\",\r\n        \"        Base::render(screen);\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename T, typename ParentEmitter>\",\r\n        \"struct EmitterDescrOnDeath\",\r\n        \"{\",\r\n        \"    T particle_type;\",\r\n        \"    fw::i32 spawn_count;\",\r\n        \"    ParentEmitter parent;\",\r\n        \"\",\r\n        \"    using Emitter = EmitterOnDeath<T, typename ParentEmitter::Emitter>;\",\r\n        \"\",\r\n        \"    Emitter spawn() const noexcept\",\r\n        \"    {\",\r\n        \"        return { particle_type, spawn_count, parent.spawn() };\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename... Emitters>\",\r\n        \"struct ParticleSystemImpl : ParticleSystem\",\r\n        \"{\",\r\n        \"    using Data = std::tuple<typename Emitters::Emitter...>;\",\r\n        \"    Data emitters_;\",\r\n        \"    fw::f32 x_;\",\r\n        \"    fw::f32 y_;\",\r\n        \"\",\r\n        \"    float total_time_ = 0.f;\",\r\n        \"\",\r\n        \"    ParticleSystemImpl(fw::f32 x, fw::f32 y, Data emitters) :\",\r\n        \"        x_{ x },\",\r\n        \"        y_{ y },\",\r\n        \"        emitters_{ emitters }\",\r\n        \"    {}\",\r\n        \"\",\r\n        \"    void update(fw::Game::TimeSpan delta_time, RandomEngine& random) override\",\r\n        \"    {\",\r\n        \"        total_time_ += delta_time.count();\",\r\n        \"        update_impl(delta_time.count(), random, std::make_index_sequence<sizeof...(Emitters)>{});\",\r\n        \"    }\",\r\n        \"    void render(fw::Surface& screen) const noexcept override\",\r\n        \"    {\",\r\n        \"        render_impl(screen, std::make_index_sequence<sizeof...(Emitters)>{});\",\r\n        \"    }\",\r\n        \"\",\r\n        \"private:\",\r\n        \"    template <size_t... Indices>\",\r\n        \"    void update_impl(float delta_time, RandomEngine& random, std::index_sequence<Indices...>)\",\r\n        \"    {\",\r\n        \"        auto _ = { (\",\r\n        \"            std::get<Indices>(emitters_).update(total_time_, delta_time, { random, x_, y_ })\",\r\n        \"            , 0)... };\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    template <size_t... Indices>\",\r\n        \"    void render_impl(fw::Surface& screen, std::index_sequence<Indices...>) const noexcept\",\r\n        \"    {\",\r\n        \"        auto _ = { (\",\r\n        \"            std::get<Indices>(emitters_).render(screen)\",\r\n        \"            , 0)... };\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"template <typename... Emitters>\",\r\n        \"struct ParticleSystemDescr\",\r\n        \"{\",\r\n        \"    std::string_view name_;\",\r\n        \"    std::tuple<Emitters...> emitters;\",\r\n        \"\",\r\n        \"    auto name() const noexcept -> std::string_view { return name_; }\",\r\n        \"    auto spawn(fw::f32 x, fw::f32 y) const -> std::unique_ptr<ParticleSystem>\",\r\n        \"    {\",\r\n        \"        return spawn_impl(x, y, std::make_index_sequence<sizeof...(Emitters)>{});\",\r\n        \"    }\",\r\n        \"\",\r\n        \"    template <size_t... Indices>\",\r\n        \"    auto spawn_impl(fw::f32 x, fw::f32 y, std::index_sequence<Indices...>) const\",\r\n        \"        -> std::unique_ptr<ParticleSystem>\",\r\n        \"    {\",\r\n        \"        return std::make_unique<ParticleSystemImpl<Emitters...>>(\",\r\n        \"            x,\",\r\n        \"            y,\",\r\n        \"            std::tuple<typename Emitters::Emitter...>{ std::get<Indices>(emitters).spawn()... }\",\r\n        \"        );\",\r\n        \"    }\",\r\n        \"};\",\r\n        \"\",\r\n        \"} // namespace particles::detail\",\r\n        \"\",\r\n        \"namespace particles\",\r\n        \"{\",\r\n        \"\",\r\n        \"template <typename... Emitters>\",\r\n        \"constexpr auto CreateParticleSystem(std::string_view name, Emitters... emitters)\",\r\n        \"{\",\r\n        \"    return detail::ParticleSystemDescr<Emitters...>{ name, std::tuple<Emitters...>{ emitters... } };\",\r\n        \"}\",\r\n        \"\",\r\n        \"template <typename T>\",\r\n        \"constexpr auto EmitContinuously(T particle_type, float spawn_rate)\",\r\n        \"    -> detail::EmitterDescrContinuous<T>\",\r\n        \"{\",\r\n        \"    return { particle_type, spawn_rate };\",\r\n        \"}\",\r\n        \"\",\r\n        \"template <typename T, typename Emitter>\",\r\n        \"constexpr auto EmitOnDeath(T particle_type, fw::i32 spawn_count, Emitter parent)\",\r\n        \"    -> detail::EmitterDescrOnDeath<T, Emitter>\",\r\n        \"{\",\r\n        \"    return { particle_type, spawn_count, parent };\",\r\n        \"}\",\r\n        \"\",\r\n        \"} // namespace particles\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 10, \"#d36971\", 9, \"#cccccc\", 2, \"#d36971\", 6 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 9 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#c8c8c8\", 13, \"#cccccc\", 5, \"#b98eb2\", 7, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 2, \"plum\", 6, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 12, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 11 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 9, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 12, \"#cccccc\", 2, \"lightgreen\", 8, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 6, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"plum\", 10, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 16, \"#c8c8c8\", 16, \"#cccccc\", 1, \"#d38569\", 9, \"#b98eb2\", 5, \"#cccccc\", 3, \"#b98eb2\", 9, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 8, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"#c8c8c8\", 16, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 3, \"#bbbbbb\", 12, \"#cccccc\", 3, \"#b98eb2\", 12, \"#cccccc\", 12, \"#b98eb2\", 12, \"#cccccc\", 11 ],\r\n        [ \"#cccccc\", 10, \"#bbbbbb\", 12, \"#cccccc\", 3, \"#d38569\", 10, \"#cccccc\", 12, \"#d3a869\", 8, \"#cccccc\", 11, \"#c8c8c8\", 16, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#d38569\", 7, \"#cccccc\", 4, \"plum\", 10, \"#cccccc\", 1, \"lightgreen\", 4, \"#cccccc\", 9, \"#819dc2\", 1, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 16 ],\r\n        [ \"plum\", 22, \"#cccccc\", 4, \"lightgreen\", 6, \"#cccccc\", 13 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 2, \"plum\", 10, \"#cccccc\", 4, \"lightgreen\", 8, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 25, \"plum\", 10, \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 22, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 1 ],\r\n        [ \"lightgreen\", 20, \"#cccccc\", 1, \"plum\", 10, \"#cccccc\", 5, \"plum\", 10, \"#cccccc\", 1, \"plum\", 10, \"#cccccc\", 1, \"lightgreen\", 4, \"#cccccc\", 5, \"#819dc2\", 1, \"#cccccc\", 3 ],\r\n        [ \"plum\", 26, \"#cccccc\", 1, \"lightgreen\", 8, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 14, \"#cccccc\", 1, \"#d3a869\", 13, \"#cccccc\", 6, \"#d38569\", 10, \"#cccccc\", 11 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"plum\", 18, \"#cccccc\", 1, \"lightgreen\", 9, \"#cccccc\", 6, \"lightgreen\", 6, \"#cccccc\", 12, \"plum\", 6, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 13, \"plum\", 1, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 10, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 12, \"#cccccc\", 1, \"#b98eb2\", 4, \"#cccccc\", 13, \"plum\", 10, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#91968b\", 39 ],\r\n        [ \"#b98eb2\", 22, \"#cccccc\", 20, \"lightgreen\", 8, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 23, \"#cccccc\", 4, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 6 ],\r\n        [ \"#b98eb2\", 23, \"#cccccc\", 4, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 6 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 6, \"#819dc2\", 2, \"#cccccc\", 14, \"#c8c8c8\", 5, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 21, \"#819dc2\", 2, \"#cccccc\", 14, \"#c8c8c8\", 6, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 31, \"#819dc2\", 10, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 18, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#d3a869\", 6, \"plum\", 5, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 4, \"plum\", 11, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 4, \"plum\", 13, \"#cccccc\", 2, \"#819dc2\", 1, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#c8c8c8\", 21, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 6, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 13 ],\r\n        [ \"plum\", 13, \"#cccccc\", 9 ],\r\n        [ \"plum\", 19, \"#cccccc\", 14 ],\r\n        [ \"#cccccc\", 7 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 8, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"#d38569\", 4, \"#cccccc\", 2, \"lightgreen\", 16, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#b98eb2\", 12, \"#cccccc\", 12, \"#b98eb2\", 12, \"#cccccc\", 11 ],\r\n        [ \"#d38569\", 18, \"#cccccc\", 12, \"#d3a869\", 8, \"#cccccc\", 11, \"#d38569\", 4, \"#cccccc\", 2, \"lightgreen\", 16, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 2, \"lightgreen\", 6, \"#cccccc\", 47 ],\r\n        [ \"#b98eb2\", 19, \"#cccccc\", 15, \"#b98eb2\", 11, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 15, \"plum\", 11, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 14, \"#cccccc\", 1, \"plum\", 13, \"#cccccc\", 15 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 14, \"plum\", 12, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 2, \"lightgreen\", 14, \"#cccccc\", 1, \"plum\", 5, \"#cccccc\", 14 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 22 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 8, \"#cccccc\", 2, \"#d38569\", 17, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#d3a869\", 6, \"plum\", 13, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"plum\", 10, \"#cccccc\", 2, \"#91968b\", 32 ],\r\n        [  ],\r\n        [ \"#d38569\", 12, \"#c8c8c8\", 5, \"#cccccc\", 3, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 2, \"plum\", 13, \"#cccccc\", 2, \"plum\", 11, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 13, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 15, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2 ],\r\n        [ \"#d3a869\", 6, \"plum\", 5, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 4, \"plum\", 12, \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 18, \"plum\", 15, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#c8c8c8\", 18, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 6, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 13, \"#d3a869\", 14, \"#cccccc\", 17 ],\r\n        [ \"plum\", 13, \"#cccccc\", 9 ],\r\n        [ \"plum\", 20, \"#cccccc\", 16 ],\r\n        [ \"plum\", 23, \"#cccccc\", 18 ],\r\n        [ \"#cccccc\", 7 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 8, \"#cccccc\", 2, \"#b98eb2\", 8, \"#cccccc\", 1, \"#d38569\", 4, \"#cccccc\", 2, \"lightgreen\", 16, \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#b98eb2\", 12, \"#cccccc\", 12, \"#b98eb2\", 12, \"#cccccc\", 11 ],\r\n        [ \"#d38569\", 18, \"#cccccc\", 12, \"#d3a869\", 8, \"#cccccc\", 11, \"#d38569\", 4, \"#cccccc\", 2, \"lightgreen\", 16, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 2, \"lightgreen\", 6, \"#cccccc\", 47 ],\r\n        [ \"plum\", 23, \"#cccccc\", 1, \"lightgreen\", 6, \"#cccccc\", 41, \"#b98eb2\", 10, \"#cccccc\", 11 ],\r\n        [ \"#cccccc\", 9 ],\r\n        [ \"#b98eb2\", 16, \"#cccccc\", 1, \"#b98eb2\", 5, \"#cccccc\", 4, \"#819dc2\", 1, \"#cccccc\", 6, \"plum\", 12, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#b98eb2\", 20, \"#cccccc\", 20, \"lightgreen\", 8, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 20, \"#cccccc\", 2, \"lightgreen\", 14, \"#cccccc\", 1, \"plum\", 5, \"#cccccc\", 15, \"plum\", 6, \"#cccccc\", 2, \"#bbbbbb\", 2, \"#cccccc\", 2, \"#bbbbbb\", 3, \"#cccccc\", 3 ],\r\n        [ \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 11 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 10, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"plum\", 23, \"#cccccc\", 1, \"lightgreen\", 6, \"#cccccc\", 9 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 2, \"lightgreen\", 6, \"#cccccc\", 9 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 13, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 19 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 6, \"plum\", 13, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 4, \"plum\", 11, \"#cccccc\", 1 ],\r\n        [ \"#d3a869\", 18, \"plum\", 6, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 8, \"#cccccc\", 2, \"#d38569\", 14, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 13, \"#cccccc\", 2, \"lightgreen\", 7, \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#d38569\", 12, \"#c8c8c8\", 5, \"#cccccc\", 3, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 2, \"plum\", 13, \"#cccccc\", 2, \"plum\", 11, \"#cccccc\", 2, \"plum\", 6, \"#cccccc\", 1, \"lightgreen\", 5, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 19, \"#cccccc\", 2, \"#d38569\", 14 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 10, \"#d38569\", 5, \"#cccccc\", 2, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 8, \"#cccccc\", 2, \"lightgreen\", 7, \"#cccccc\", 5 ],\r\n        [ \"#d38569\", 9, \"plum\", 9, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 4, \"plum\", 2, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 4, \"plum\", 2, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"plum\", 12, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#c8c8c8\", 22, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 3, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 3, \"#d38569\", 5, \"#cccccc\", 11 ],\r\n        [ \"plum\", 10, \"#cccccc\", 6 ],\r\n        [ \"plum\", 10, \"#cccccc\", 6 ],\r\n        [ \"plum\", 17, \"#cccccc\", 12 ],\r\n        [ \"#cccccc\", 6 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 2, \"#d38569\", 9, \"#cccccc\", 12, \"#d38569\", 12, \"#cccccc\", 10, \"#b98eb2\", 8 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"plum\", 20, \"#cccccc\", 14, \"#c8c8c8\", 5, \"#cccccc\", 3 ],\r\n        [ \"lightgreen\", 19, \"#cccccc\", 12, \"#c8c8c8\", 5, \"#cccccc\", 12, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 19, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 4, \"#d38569\", 8, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 6, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 10, \"#b98eb2\", 23 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"lightgreen\", 19, \"#cccccc\", 9, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 19, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 4, \"#d38569\", 8, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 4, \"#d3a869\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 12, \"#d38569\", 12, \"#cccccc\", 10, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 14, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 7 ],\r\n        [ \"#d36971\", 15, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 2, \"plum\", 9, \"#cccccc\", 2, \"lightgreen\", 6, \"#cccccc\", 1, \"plum\", 11, \"#cccccc\", 24, \"plum\", 2, \"#cccccc\", 2, \"plum\", 3, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 14, \"#819dc2\", 1, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 4, \"#d3a869\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 11, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 7, \"#cccccc\", 10, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 14, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 6, \"#b98eb2\", 14 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 7 ],\r\n        [ \"#d36971\", 15, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 2, \"plum\", 9, \"#cccccc\", 2, \"lightgreen\", 6, \"#cccccc\", 8 ],\r\n        [ \"#cccccc\", 14, \"#819dc2\", 1, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 7, \"#d38569\", 19 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 12, \"plum\", 5, \"#cccccc\", 1 ],\r\n        [ \"#d36971\", 7, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 1, \"#d3a869\", 8, \"#cccccc\", 5, \"plum\", 8, \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 4, \"#cccccc\", 3, \"#b98eb2\", 15, \"#cccccc\", 3, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 2, \"#b98eb2\", 7, \"plum\", 5, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 5, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 3, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 3, \"#b98eb2\", 6, \"#cccccc\", 3, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 10, \"#cccccc\", 1, \"#d38569\", 14, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"lightgreen\", 10, \"#cccccc\", 7, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 19, \"#cccccc\", 1, \"#b98eb2\", 6, \"#cccccc\", 4, \"#d38569\", 8, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 13, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 4, \"#d3a869\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 9, \"#c8c8c8\", 10, \"#cccccc\", 1, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 3, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 3, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 14, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 6, \"#b98eb2\", 5 ],\r\n        [ \"#cccccc\", 11, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 10, \"#cccccc\", 1, \"#d38569\", 14, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#b98eb2\", 15, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 11, \"#cccccc\", 1, \"#d38569\", 18, \"#cccccc\", 1, \"#d3a869\", 8, \"#cccccc\", 6 ],\r\n        [ \"#cccccc\", 14 ],\r\n        [ \"#cccccc\", 14 ],\r\n        [ \"#d36971\", 15, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 8, \"#cccccc\", 2, \"lightgreen\", 7, \"#cccccc\", 6, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 3, \"#cccccc\", 1, \"#d3a869\", 7, \"#cccccc\", 2, \"plum\", 8, \"#cccccc\", 2, \"lightgreen\", 5, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 10 ],\r\n        [ \"#cccccc\", 5 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 30 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 10, \"#d36971\", 9 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 8, \"#cccccc\", 4, \"#d3a869\", 8, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 20, \"#cccccc\", 1, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 12, \"#cccccc\", 6, \"#d3a869\", 8, \"#cccccc\", 13 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 19, \"#cccccc\", 1, \"#d3a869\", 8, \"#cccccc\", 12, \"#d36971\", 3, \"#cccccc\", 2, \"#d38569\", 5, \"#cccccc\", 1, \"#d3a869\", 8, \"#cccccc\", 22 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 16, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 15, \"#b98eb2\", 6, \"#cccccc\", 11 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 22, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 30 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 9, \"#cccccc\", 1, \"#b98eb2\", 9, \"#d3a869\", 1, \"#cccccc\", 2, \"#b98eb2\", 9, \"#d3a869\", 7, \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 15, \"#d38569\", 11, \"#cccccc\", 1, \"#d3a869\", 2, \"#cccccc\", 15, \"#d36971\", 2, \"#cccccc\", 2, \"#d38569\", 4, \"#cccccc\", 13, \"#d3a869\", 8, \"#cccccc\", 7 ],\r\n        [ \"#cccccc\", 7, \"#d36971\", 6, \"#cccccc\", 2, \"#d38569\", 19, \"#cccccc\", 1, \"#d3a869\", 1, \"#cccccc\", 2, \"#d3a869\", 7, \"#cccccc\", 1 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [ \"#b98eb2\", 11, \"#cccccc\", 39 ],\r\n        [ \"#cccccc\", 1 ],\r\n        [  ],\r\n        [ \"#cccccc\", 2, \"#91968b\", 22 ]\r\n    ]\r\n}",
	"content/code/53_exercise.json": "{\r\n    \"sets\": {\r\n        \"main\": [\r\n            [\"sl\", [1,5]],\r\n            [\"hl\", [1,5], \"sl\", [28,39]],\r\n            [\"sl\", [45,47]],\r\n            null\r\n        ]\r\n    },\r\n    \"lines\": [\r\n        \"constexpr auto fire = CreateParticleType(\",\r\n        \"    Lifetime(Random{ 0.2f, 0.8f }),\",\r\n        \"    Position(Random{ -2.f, 2.f }),\",\r\n        \"    Velocity(Random{ -4.f, 4.f }, Random{ 0.f, 50.f })\",\r\n        \");\",\r\n        \"\",\r\n        \"constexpr auto sparks = CreateParticleType(\",\r\n        \"    Lifetime(Random{ 0.2f, 0.4f }),\",\r\n        \"    Position(Random{ -4.f, 4.f }),\",\r\n        \"    Velocity(Random{ -200.f, 200.f }),\",\r\n        \"    Acceleration(Constant{ 0.5f }, Constant{ -1500.f }),\",\r\n        \"    Drag(Constant{ 3.f })\",\r\n        \");\",\r\n        \"\",\r\n        \"constexpr auto swarm = CreateParticleType(\",\r\n        \"    Lifetime(Constant{ 1.f }),\",\r\n        \"    Position(Random{ -7.5f, 7.5f }),\",\r\n        \"    Acceleration(Polar{ 0.f, 15.f }),\",\r\n        \"    Drag(Constant{ 0.5f })\",\r\n        \");\",\r\n        \"\",\r\n        \"constexpr auto rain = CreateParticleType(\",\r\n        \"    Lifetime(Constant{ 1.f }),\",\r\n        \"    Position(Random{ -20.f, 0.f }, Constant { 10.f }),\",\r\n        \"    Velocity(Random{ 75.f, 85.f }, Random{ -410.f, -390.f })\",\r\n        \");\",\r\n        \"\",\r\n        \"constexpr auto firework_rocket = CreateParticleType(\",\r\n        \"    Lifetime(Random{ 0.4f, 0.5f }),\",\r\n        \"    Position(Constant{ 0.f }),\",\r\n        \"    Velocity(Polar{ 250.f, 350.f, pi * 0.45f, pi * 0.55f }),\",\r\n        \"    Acceleration(Constant{ 0.f }, Constant{ -300.f })\",\r\n        \");\",\r\n        \"constexpr auto firework_explosion = CreateParticleType(\",\r\n        \"    Lifetime(Random{ 0.6f, 0.9f }),\",\r\n        \"    Velocity(Polar{ 150.f, 200.f }),\",\r\n        \"    Acceleration(Constant{ 0.f }, Constant{ -100.f }),\",\r\n        \"    Drag(Constant{ 2.f })\",\r\n        \");\",\r\n        \"\",\r\n        \"constexpr auto fire_system     = CreateParticleSystem(\\\"fire\\\"sv,   EmitContinuously(fire,   20.f));\",\r\n        \"constexpr auto sparks_system   = CreateParticleSystem(\\\"sparks\\\"sv, EmitContinuously(sparks, 120.f));\",\r\n        \"constexpr auto swarm_system    = CreateParticleSystem(\\\"swarm\\\"sv,  EmitContinuously(swarm,  20.f));\",\r\n        \"constexpr auto rain_system     = CreateParticleSystem(\\\"rain\\\"sv,   EmitContinuously(rain,   40.f));\",\r\n        \"constexpr auto firework_system = CreateParticleSystem(\\\"firework\\\"sv,\",\r\n        \"    EmitOnDeath(firework_explosion, 100, EmitContinuously(firework_rocket, 0.75f))\",\r\n        \");\"\r\n    ],\r\n    \"tokens\": [\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 7, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 9, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 5, \"#cccccc\", 2, \"#819dc2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3, \"#d38569\", 8, \"#cccccc\", 3, \"#819dc2\", 7, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 8, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 8, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 5, \"#cccccc\", 2, \"#819dc2\", 3, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 8, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 7, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3, \"#d38569\", 9, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3, \"#d38569\", 6, \"#cccccc\", 3, \"#819dc2\", 5, \"#cccccc\", 3, \"#819dc2\", 6, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 18, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 5, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 7, \"#819dc2\", 5, \"#cccccc\", 7, \"#819dc2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3, \"#d38569\", 8, \"#cccccc\", 3, \"#819dc2\", 6, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 21, \"#d38569\", 18, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 6, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 12, \"#cccccc\", 1, \"#d38569\", 5, \"#cccccc\", 2, \"#819dc2\", 5, \"#cccccc\", 2, \"#819dc2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 16, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 3, \"#d38569\", 8, \"#cccccc\", 3, \"#819dc2\", 6, \"#cccccc\", 3 ],\r\n        [ \"#d38569\", 8, \"#cccccc\", 1, \"#d38569\", 8, \"#cccccc\", 2, \"#819dc2\", 4, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ],\r\n        [  ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 18, \"#d38569\", 20, \"#cccccc\", 1, \"#7da76f\", 8, \"#cccccc\", 4, \"#d38569\", 16, \"#cccccc\", 9, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 18, \"#d38569\", 20, \"#cccccc\", 1, \"#7da76f\", 10, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 9, \"#819dc2\", 5, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 18, \"#d38569\", 20, \"#cccccc\", 1, \"#7da76f\", 9, \"#cccccc\", 3, \"#d38569\", 16, \"#cccccc\", 9, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 18, \"#d38569\", 20, \"#cccccc\", 1, \"#7da76f\", 8, \"#cccccc\", 4, \"#d38569\", 16, \"#cccccc\", 9, \"#819dc2\", 4, \"#cccccc\", 3 ],\r\n        [ \"#b98eb2\", 15, \"#cccccc\", 18, \"#d38569\", 20, \"#cccccc\", 1, \"#7da76f\", 12, \"#cccccc\", 1 ],\r\n        [ \"#d38569\", 15, \"#cccccc\", 21, \"#819dc2\", 3, \"#cccccc\", 2, \"#d38569\", 16, \"#cccccc\", 18, \"#819dc2\", 5, \"#cccccc\", 2 ],\r\n        [ \"#cccccc\", 2 ]\r\n    ]\r\n}"
}